DECLARE FUNCTION FileExist% (A$)
DEFINT A-Z
' ANSI Emulation for QuickBASIC (4.5)      By Brett Emery - 1990

' Noted Bug:  If file runs out during and ANSI ESC sequence, an error will
'             occur.  If this is a problem then check for EOF() before each
'             INPUT$ function.


A$ = COMMAND$
R = 0: C = 7                               ' Set Colors (R=Reverse, C=Color)

IF A$ = "" THEN
   PRINT "ANSI File Displayer 1.0 - QuickBASIC (4.5) - 1990 Brett Emery"
   PRINT
   PRINT "   Usage: ANSI <filename>"
   PRINT
   LINE INPUT "Enter file to ANSI view: "; A$
END IF
IF A$ = "" THEN
   PRINT "No file specified.": END
END IF

IF NOT FileExist(A$) THEN
   PRINT "File does NOT exist!"
   END
END IF

OPEN A$ FOR INPUT AS #1

WHILE NOT EOF(1)                                ' Process entire file
   GOSUB GET.IN:
   IF INKEY$ <> "" THEN
      PRINT : PRINT "* ABORTED *"
      END
   END IF
WEND
END

GET.IN:
B$ = INPUT$(1, #1)
SELECT CASE B$
   CASE CHR$(10): LOCATE , 1
   CASE CHR$(27)                                ' ANSI code found
      B$ = INPUT$(1, #1)
      IF B$ = "[" THEN
         E$ = "": B$ = ";"
         WHILE INSTR("0123456789;", B$) > 0     ' Get full ANSI code into E$
            B$ = INPUT$(1, #1)
            E$ = E$ + B$
         WEND
         GOSUB ANSI:                            ' Process ANSI code
      ELSE
         PRINT CHR$(27) + B$;                   ' Not ANSI code, print text
      END IF
   CASE ELSE
      PRINT B$;                                 ' Not ANSI code, print text
END SELECT
RETURN

ANSI:
X = POS(1): Y = CSRLIN: OX = X: OY = Y: Q = 0          ' Save current position
B$ = E$ + ";": PARM = INSTR(B$, ";")                   ' Append E$ & ; to B$
E$ = RIGHT$(E$, 1)                                     ' Put ANSI Command in E$
WHILE PARM                                             ' Put each ANSI code
   Q = Q + 1: P$(Q) = LEFT$(B$, PARM - 1)              '   Into it's own array
   B$ = MID$(B$, PARM + 1)
   PARM = INSTR(B$, ";")
WEND
P$(Q) = LEFT$(P$(Q), LEN(P$(Q)) - 1)
FOR T = 1 TO Q                                         ' Process ANSI codes
   Code = VAL(P$(T))
   SELECT CASE E$
   CASE "m"
   SELECT CASE Code
      CASE 0: BO = 0: BL = 0: R = 0: C = 7: BK = 0
      CASE 1: BO = 8
      CASE 2: BO = 0
      CASE 5: BL = 16
      CASE 6: BL = 16
      CASE 7: R = -1
      CASE 8: C = 7
      CASE 30: C = 0
      CASE 31: C = 4
      CASE 32: C = 2
      CASE 33: C = 6
      CASE 34: C = 1
      CASE 35: C = 5
      CASE 36: C = 3
      CASE 37: C = 7
      CASE 40: BK = 0
      CASE 41: BK = 4
      CASE 42: BK = 2
      CASE 43: BK = 6
      CASE 44: BK = 1
      CASE 45: BK = 5
      CASE 46: BK = 3
      CASE 47: BK = 7
   END SELECT
   CASE "n"
      IF VAL(E$) = 6 THEN PRINT #1, CHR$(27) + "["; X; ";"; Y; "R"
   CASE "J": CLS : X = 1: Y = 1
   CASE "F": ' LOCATE POSITION (Not normally used, use "H" instead)
      IF Q = 2 THEN
         X = VAL(P$(2))
         Y = VAL(P$(1))
         T = Q
      ELSEIF Q = 1 THEN
         Y = VAL(P$(1)): X = 1
      ELSE
         Y = 1: X = 1
      END IF
   CASE "H": ' LOCATE POSITION
      IF Q = 2 THEN
         X = VAL(P$(2))
         Y = VAL(P$(1))
         T = Q
      ELSEIF Q = 1 THEN
         Y = VAL(P$(1)): X = 1
      ELSE
         Y = 1: X = 1
      END IF
   CASE "A": IF Code = 0 THEN Y = Y - 1 ELSE Y = Y - Code ' Up
   CASE "B": IF Code = 0 THEN Y = Y + 1 ELSE Y = Y + Code ' Down
   CASE "C": IF Code = 0 THEN X = X + 1 ELSE X = X + Code ' Right
   CASE "D": IF Code = 0 THEN X = X - 1 ELSE X = X - Code ' Left
   CASE "s": MY = Y: MX = X' REMEMBER POSITION
   CASE "u": Y = MY: X = MX: LOCATE Y, X: ' RESTORE REMEMBERED POSITION
   CASE "K": PRINT SPACE$(80 - X); : LOCATE Y, X ' DELETE TO EOL
   END SELECT
NEXT
F = C + BL + BO                                  ' Calculate Color
IF (OX <> X) OR (OY <> Y) THEN                   ' Check to see position
   IF X > 254 THEN X = 80
   WHILE X > 80: X = X - 80: Y = Y + 1: WEND
   IF X < 1 THEN X = 1
   IF Y < 1 THEN Y = 1
   IF Y > 24 THEN Y = 24
   LOCATE Y, X
END IF
IF (OB <> BK) OR (OF <> F) THEN                  ' Change color
   IF R THEN
      WHILE F > 7: F = F / 2: WEND
      COLOR BK, F
   ELSE
      COLOR F, BK
   END IF
   OB = BK: OF = F
END IF
RETURN

FUNCTION FileExist% (A$)
' Check to see if a file exists on disk
' Only bug is 0 byte files will NOT be detected and WILL be deleted.

OPEN A$ FOR BINARY AS #1: B = LOF(1): CLOSE
IF B = 0 THEN
   FileExist = 0
   KILL A$
ELSE
   FileExist = -1
END IF

END FUNCTION

