' .------------------------------------------------------.
' | BIN2QB.BAS v3.4  by Allan Zachary Public Domain 7/92 |
' |    (with minor modifications for use with PDS v7.1   |
' |     by Mark H Butler 8/92)                           |
' |  Converts binary files to echo-compatible text files |
' |  version 3.4 - replaces a fallible checksum in v3.1  |
' | < Bar Charts progress, Manual or Batch style input > |
' |     BATCH SYNTAX: BIN2QB infile.ext                  |
' |        an output file infile.bas will be created     |
' `------------------------------------------------------'
DEFINT A-Z
DECLARE SUB Usage ()
DECLARE FUNCTION BasFile$ (FileName$)
DECLARE FUNCTION Exists% (FileName$)
DECLARE FUNCTION Bin2Txt$ (ThreeBytes$)  ' 3 binary bytes in returns
DIM SHARED XCk&                          ' 4 printable Text bytes out

    Q$ = CHR$(34)
    COLOR 14, 0
    PRINT
    PRINT "BIN2QB 3.4 by Allan Zachary, in public domain July 1992"
    MaxFileSz& = 32760
    InFile$ = RTRIM$(COMMAND$)
    IF InFile$ = "" THEN
        COLOR 12, 0
        PRINT
        PRINT "Error: no input file specified"
        COLOR 7, 0
        Usage
    ELSEIF NOT Exists%(InFile$) THEN
        COLOR 12, 0
        PRINT
        PRINT "Error: "; InFile$; " was not found."
        COLOR 7, 0
        Usage
    END IF
    sp% = INSTR(InFile$, " ")
    IF sp% THEN
        InFile$ = LEFT$(InFile$, sp% - 1)
    END IF
    OutFile$ = BasFile$(InFile$)
    COLOR 12, 0
    OPEN InFile$ FOR BINARY AS #2
    Size& = LOF(2)
    FSiz& = Size&
    IF Size& > MaxFileSz& THEN
        PRINT "Aborted- File too large for Bin2Qb!"
        BEEP: COLOR 7, 0: END
    END IF
    IF Size& THEN
        IF Exists%(OutFile$) THEN
            COLOR 12, 0
            PRINT
            PRINT "Error: "; OutFile$; " already exists!!"
            COLOR 7, 0
            Usage
        END IF
DoIt:
        CLOSE #1:
        COLOR 11, 0
        PRINT
        PRINT "Creating: "; OutFile$
        OPEN OutFile$ FOR OUTPUT AS #1
        PRINT #1, " DEFINT A-Z  ' Created by BIN2QB 3.4 freeware 7/92"
        PRINT #1, " f$="; Q$; InFile$; Q$; ":LSBs=3"
        PRINT #1, " CLS : PRINT "; Q$; "Creating "; Q$; ";f$"
        PRINT #1, " OPEN f$ FOR BINARY AS #1 :FSize&="; FSiz&
        PRINT #1, " ON ERROR GOTO Done:LOCATE 2,1:PRINT STRING$(50,176)"
        PRINT #1, " DO:READ Lyne$:LynLen=LEN(Lyne$)"
        PRINT #1, "  FOR i=1 TO LynLen "
        PRINT #1, "    Power=((i-1)MOD 4)*6"
        PRINT #1, "    B&=(ASC(MID$(Lyne$,i,1))-59)*2^Power:C&=C&+B&"
        PRINT #1, "    IF i MOD 4=0 THEN"
        PRINT #1, "      Stored&=Stored&+3:XCk&=XCk& XOR C&:LOCATE 2,1"
        PRINT #1, "      PRINT STRING$(CINT(Stored&/FSize&*50),219):LOCATE 2,53"
        PRINT #1, "      PRINT USING "; Q$; "###"; Q$; ";CINT(Stored&/FSize&*50)*2;"
        PRINT #1, "      PRINT "; Q$; "%"; Q$; ":IF Stored&>FSize& THEN LSBs=3+(FSize&-Stored&)"
        PRINT #1, "      Bin$=LEFT$(MKL$(C&),LSBs):PUT #1,,Bin$:C&=0"
        PRINT #1, "    END IF"
        PRINT #1, "  NEXT i:LOOP"
        Lyne$ = " DATA "
        BufSz& = FRE(Buf$) - 1024
        IF BufSz& > Size& THEN BufSz& = Size&
        Buf$ = SPACE$(BufSz&)
        row% = CSRLIN
        PRINT STRING$(50, 176); : COLOR 10, 0
        DO
            GET #2, , Buf$
            FOR i = 1 TO LEN(Buf$)
                Done& = Done& + 1
                Ascii = ASC(MID$(Buf$, i, 1))
                Bin$ = Bin$ + CHR$(Ascii)
                IF LEN(Bin$) = 3 THEN
                    IF LEN(Lyne$) >= 69 THEN 'save it, and start a new line...
                        PRINT #1, Lyne$
                        LOCATE row%, 1
                        PRINT STRING$(CINT(Done& / Size& * 50), 219);
                        IF Size& THEN
                            COLOR 11
                            LOCATE row%, 53
                            PRINT USING "###"; CINT(Done& / Size& * 50) * 2;
                            PRINT "%";
                            COLOR 10
                        END IF
                        Lyne$ = " DATA " + Bin2Txt$(Bin$)
                    ELSE 'keep building this line...
                        Lyne$ = Lyne$ + Bin2Txt$(Bin$)
                    END IF
                    Bin$ = ""
                END IF
            NEXT i
            Size& = Size& - BufSz&
            IF BufSz& > Size& THEN BufSz& = Size&
            Buf$ = SPACE$(BufSz&)
        LOOP WHILE LEN(Buf$)    'Until the last character has been read.
        Size& = LEN(Bin$)
        IF Size& THEN Bin$ = Bin2Txt$(Bin$)
        IF LEN(Lyne$) >= 69 THEN
            PRINT #1, Lyne$
            IF Size& THEN PRINT #1, " DATA " + Bin$
        ELSE
            PRINT #1, Lyne$ + Bin$
        END IF
        LOCATE row%, 1
        PRINT STRING$(CINT(Done& / FSiz& * 50), 219);
        IF FSiz& THEN
            COLOR 11
            LOCATE row%, 53
            PRINT USING "###"; CINT(Done& / FSiz& * 50) * 2;
            PRINT "%";
            COLOR 10
        END IF
        PRINT #1, " Done:CLOSE #1: PRINT"
        PRINT #1, " IF XCk&<>"; XCk&; " THEN "
        PRINT #1, "   PRINT "; Q$; "DATA corrupt!  File deleted."; Q$
        PRINT #1, "   KILL f$"
        PRINT #1, " ELSE"
        PRINT #1, "   PRINT f$;"; Q$; " created."; Q$
        PRINT #1, " END IF:END"
        CLOSE
        COLOR 11, 0
        PRINT
        PRINT "...Done"
    ELSE
        PRINT InFile$; " doesn't exist, or has no length!"
        CLOSE
    END IF
    COLOR 7, 0

FUNCTION BasFile$ (FileName$) STATIC
    Extension = INSTR(FileName$, ".")
    IF Extension > 0 THEN
        BasFile$ = LEFT$(FileName$, Extension - 1) + ".BAS"
    ELSE
        BasFile$ = FileName$ + ".BAS"
    END IF
END FUNCTION

FUNCTION Bin2Txt$ (ThreeBytes$)
  L = LEN(ThreeBytes$)
  N& = CVL(ThreeBytes$ + STRING$(4 - L, 0))
  XCk& = XCk& XOR N&
  FourBytes$ = ""'             .---Offset into Character set
  FOR j = 1 TO 4 '             |
    Tmp$ = CHR$((N& AND 63) + 59)
    N& = N& \ 64
    FourBytes$ = FourBytes$ + Tmp$
  NEXT j
  Bin2Txt$ = FourBytes$
END FUNCTION

FUNCTION Exists% (FileName$)
    IF LEN(DIR$(FileName$)) = 0 THEN
        Exists% = 0
    ELSE
        Exists% = -1
    END IF
END FUNCTION

SUB Usage
    BEEP
    COLOR 11
    PRINT
    PRINT "Usage: bin2qb filename.ext"
    PRINT
    PRINT "where filename.ext is a binary file to convert"
    PRINT "to printable character DATA statements."
    COLOR 7, 0
    END
END SUB

