'****************************************************
'**** QBBOXES.BAS by Mark H Butler              *****
'**** To run in the QB45 Environment enter...   *****
'****       QB/L QB45LIB.QLB BOXES.BAS          *****
'**** or to run in PDS71 Environment enter...   *****
'****       QBX/L PDS71LIB.QLB BOXES.BAS        *****
'****************************************************

DEFINT A-Z
DECLARE SUB Drawbox (Uprow, Ltcol, Lorow, Rtcol)
DECLARE SUB Expand (Uprow, Ltcol, Lorow, Rtcol)
DECLARE SUB Explode (Uprow, Ltcol, Lorow, Rtcol)
DECLARE SUB HDivide (Hzrow, Ltcol, Rtcol)
DECLARE SUB VDivide (Uprow, Vtcol, Lorow)
DECLARE SUB MemCopy (fromseg, fromoff, destseg, destoff, nbytes)
DECLARE SUB Pause (ticks)
DECLARE SUB RestScrn (Scr())
DECLARE SUB SaveScrn (Scr())
DECLARE SUB Shade (Uprow, Ltcol, Lorow, Rtcol)
DIM SHARED ScrA(4000), ScrB(4000), ScrC(4000), ScrD(4000), ScrE(4000), ScrF(4000), ScrG(4000)

    COLOR 7, 1
    CLS
    FOR i = 1 TO 13
        FOR ch = 33 TO 176
            PRINT CHR$(ch);
        NEXT ch
    NEXT i

    SaveScrn ScrA()
    COLOR 15, 4
    Explode 5, 20, 15, 55
    SLEEP 1

    SaveScrn ScrB()
    COLOR 0, 3
    Explode 7, 25, 19, 50
    SLEEP 1

    SaveScrn ScrC()
    COLOR 15, 2
    Explode 10, 10, 20, 40
    SLEEP 1

    SaveScrn ScrD()
    COLOR 0, 7
    Explode 12, 33, 17, 75
    SLEEP 1

    SaveScrn ScrE()
    COLOR 0, 1
    Explode 9, 15, 22, 40
    SLEEP 1

    SaveScrn ScrF()
    COLOR 15, 3
    Explode 2, 5, 15, 35
    HDivide 8, 5, 35
    SLEEP 1

    SaveScrn ScrG()
    COLOR 10, 2
    Explode 6, 50, 18, 75
    VDivide 6, 62, 18
    COLOR 7, 0
    SLEEP 1

    SLEEP 1
    RestScrn ScrG()
    SLEEP 1
    RestScrn ScrF()
    SLEEP 1
    RestScrn ScrE()
    SLEEP 1
    RestScrn ScrD()
    SLEEP 1
    RestScrn ScrC()
    SLEEP 1
    RestScrn ScrB()
    SLEEP 1
    RestScrn ScrA()

SUB Drawbox (Uprow, Ltcol, Lorow, Rtcol) STATIC
 Wide = (Rtcol - Ltcol) - 1
 LOCATE Uprow, Ltcol
 PRINT CHR$(201); STRING$(Wide, CHR$(205)); CHR$(187);
 FOR i = Uprow + 1 TO Lorow - 1
        LOCATE i, Ltcol
        PRINT CHR$(186); SPACE$(Wide); CHR$(186);
 NEXT i
 LOCATE Lorow, Ltcol
 PRINT CHR$(200); STRING$(Wide, CHR$(205)); CHR$(188);
 Shade Uprow, Ltcol, Lorow, Rtcol
END SUB

SUB Expand (Uprow, Ltcol, Lorow, Rtcol) STATIC
    RowCenter = ((Lorow - Uprow) \ 2) + Uprow
    ColCenter = ((Rtcol - Ltcol) \ 2) + Ltcol
    UprRow = RowCenter: LeftCol = ColCenter
    LwrRow = RowCenter: RghtCol = ColCenter
    DO
        LeftCol = LeftCol - 1
        RghtCol = RghtCol + 1
        IF LeftCol < Ltcol THEN LeftCol = Ltcol
        IF RghtCol > Rtcol THEN RghtCol = Rtcol
        Drawbox UprRow, LeftCol, LwrRow, RghtCol
        IF LeftCol = Ltcol AND RghtCol = Rtcol THEN EXIT DO
    LOOP
    DO
        UprRow = UprRow - 1
        LwrRow = LwrRow + 1
        IF UprRow < Uprow THEN UprRow = Uprow
        IF LwrRow >= Lorow THEN LwrRow = Lorow
        Drawbox UprRow, LeftCol, LwrRow, RghtCol
        IF UprRow = Uprow AND LwrRow = Lorow THEN EXIT DO
    LOOP
    Shade Uprow, Ltcol, Lorow, Rtcol
END SUB

SUB Explode (Uprow, Ltcol, Lorow, Rtcol) STATIC
    RowCenter = ((Lorow - Uprow) \ 2) + Uprow
    ColCenter = ((Rtcol - Ltcol) \ 2) + Ltcol
    UprRow = RowCenter: LeftCol = ColCenter
    LwrRow = RowCenter: RghtCol = ColCenter
    DO
        UprRow = UprRow - 1
        LeftCol = LeftCol - 3
        LwrRow = LwrRow + 1
        RghtCol = RghtCol + 3
        IF UprRow < Uprow THEN UprRow = Uprow
        IF LeftCol < Ltcol THEN LeftCol = Ltcol
        IF LwrRow > Lorow THEN LwrRow = Lorow
        IF RghtCol > Rtcol THEN RghtCol = Rtcol
        Drawbox UprRow, LeftCol, LwrRow, RghtCol
        IF UprRow = Uprow AND LeftCol = Ltcol AND LwrRow = Lorow AND RghtCol = Rtcol THEN
            EXIT DO
        END IF
    LOOP
    Shade Uprow, Ltcol, Lorow, Rtcol
END SUB

SUB HDivide (Hzrow, Ltcol, Rtcol) STATIC
    length = Rtcol - Ltcol - 1
    LOCATE Hzrow, Ltcol
    PRINT ""; STRING$(length, ""); ""
END SUB

SUB hold

END SUB

SUB Pause (ticks%)
    DEF SEG = 0
    DO UNTIL TestTick% > ticks% * 18
        IF LEN(INKEY$) THEN EXIT SUB
        LastTick% = GetTick%
        GetTick% = PEEK(&H46C)
        IF LastTick% <> GetTick% THEN
            TestTick% = TestTick% + 1
        END IF
    LOOP
    DEF SEG
END SUB

SUB RestScrn (Scr())
    DEF SEG = &H40
    equip = PEEK(&H10)
    IF (equip AND 48) = 48 THEN
        destseg = &HB000
    ELSE
        destseg = &HB800
    END IF
    destoff = 0
    fromseg = VARSEG(Scr(0))
    fromoff = VARPTR(Scr(0))
    nbytes = 4000
    MemCopy fromseg, fromoff, destseg, destoff, nbytes
END SUB

SUB SaveScrn (Scr())
    DEF SEG = &H40
    equip = PEEK(&H10)
    IF (equip AND 48) = 48 THEN
        fromseg = &HB000
    ELSE
        fromseg = &HB800
    END IF
    fromoff = 0
    destseg = VARSEG(Scr(0))
    destoff = VARPTR(Scr(0))
    nbytes = 4000
    MemCopy fromseg, fromoff, destseg, destoff, nbytes
END SUB

SUB Shade (Uprow, Ltcol, Lorow, Rtcol) STATIC
    DEF SEG = &H40
    equip = PEEK(&H10)
    IF (equip AND 48) = 48 THEN
        EXIT SUB    '*** no use in doing it if it's monochrome, right?
    ELSE
        DEF SEG = &HB800
    END IF

'*********************************************************
'****** find out what the screen attribute  **************
'****** already is (underneath the box) ******************
'*********************************************************


    attr = SCREEN(Lorow + 1, Rtcol + 1, -1)  ' Obtain the color attribute
    attr = attr AND 15                       ' Calculate forground color.
    attr = attr - 8                          ' Remove bright from the color
    IF attr < 1 THEN attr = 8                ' In case color wasn't bright

'*********************************************************
'****** use the given box dimensions to POKE a ***********
'****** "Shade" on the right side and bottom edge *******
'*********************************************************


    FOR row = Uprow + 1 TO Lorow + 1       '***** right edge locations. ***
        FOR Col = Rtcol + 1 TO Rtcol + 2   '***** make it 2 chars wide. ***
            offset = (row - 1) * 160 + (Col - 1) * 2 + 1
            POKE offset, attr
        NEXT
    NEXT

    row = Lorow + 1                        '***** now POKE along the ******
    FOR Col = Ltcol + 2 TO Rtcol + 2       '***** bottom edge *************
        offset = (row - 1) * 160 + (Col - 1) * 2 + 1
        POKE offset, attr
    NEXT
    DEF SEG

END SUB

SUB VDivide (Uprow, Vtcol, Lorow) STATIC
    length = Lorow - Uprow - 1
    LOCATE Uprow, Vtcol
    PRINT "";
    FOR i = Uprow + 1 TO Lorow - 1
        LOCATE i, Vtcol
        PRINT "";
    NEXT i
    LOCATE Lorow, Vtcol
    PRINT "";
END SUB

