'==============================================================================
'                               BT8 V1.0 beta.
'                        The best 8 bit->7 bit converter
'                     By Coridon Henshaw (fidonet#1:250/820)
'==============================================================================

'
'NOTE: Extended features (CRC checking, date/time preservation are disabled
'      until you extract the support libarary, uncomment all calls to
'      GetCRC&, InitCrcTab, CalcCRC, ResetCRC and InterruptX and uncomment
'      the DECLARE statments for the above routines.
'
'      Do not convert any files to 7 bit format until you have done the above
'      steps.  Ignore the "Bad CRC!" error when unpacking the support lib.
'

DEFINT A-Z

TYPE RegTypeX
     ax    AS INTEGER
     bx    AS INTEGER
     cx    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
     ds    AS INTEGER
     es    AS INTEGER
END TYPE

DECLARE SUB Encode8 (Infile$, Outfile$)
DECLARE SUB Decode8 (Infile$)
DECLARE SUB SetFileDateTime (f$, xYear%, xMonth%, xDay%, xHour%, xMinute%, xSecond%, ECode%)
DECLARE SUB GetFileDateTime (f$, FileDate$, FileTime$, ECode%)

DECLARE FUNCTION CRC$ (File%)
DECLARE FUNCTION StripName$ (Infile$)
DECLARE FUNCTION GetChars$ (Filenumber%, Chars%, Flag%)

'External routines found in BT8.LIB:

DECLARE FUNCTION GetCRC&
DECLARE SUB InitCrcTab (BYVAL HighWord%, BYVAL LowWord%)
DECLARE SUB CalcCRC (BYVAL BufferSeg%, BYVAL BufferOff%, BYVAL BufferLen%)
DECLARE SUB ResetCRC
DECLARE SUB InterruptX (IntNum AS INTEGER, InReg AS RegTypeX, OutReg AS RegTypeX)
'
' Uncomment above lines AFTER you have unpacked the support lib.
'
CONST Header8 = "START 8,"  '
CONST Footer8 = "END "      'Modify at your own risk
CONST LineLength = 72

PRINT "BT8 v1.0 beta"
PRINT
PRINT "Mode:"
PRINT
PRINT "0) Quit"
PRINT "1) BT8 encode"
PRINT "2) BT8 decode"

DO
    IKey$ = INKEY$
LOOP UNTIL IKey$ = "0" OR IKey$ = "1" OR IKey$ = "2"

SELECT CASE IKey$
    CASE "1"
        LINE INPUT "Input file: ", Infile$
        LINE INPUT "Output file: ", Outfile$
        PRINT
        PRINT "Encoding.  This may take some time."
        PRINT "Press any key to abort.  BT8 will beep when done."
        PRINT
        Encode8 Infile$, Outfile$
        PLAY "A"
    CASE "2"
        LINE INPUT "Input file: ", Infile$
        PRINT
        PRINT "Decoding.  This may take some time."
        PRINT "Press any key to abort.  BT8 will beep when done."
        PRINT
        Decode8 Infile$
        PLAY "A"
END SELECT

FUNCTION CRC$ (File)
'InitCrcTab &HEDB8, &H8320   'Init CRC routines

FPos& = SEEK(File)          'Save position in file
SEEK File, 1                'Set filepos to start of file
BLft& = LOF(File) - LOC(File)'How many more bytes left?

DO
    IF BLft& >= 32767 THEN      'Do we have 32K or more bytes to read?
        Buffer$ = ""
        Buffer$ = STRING$(32766, 0)'Yup
    ELSE                        'Nope,
        Buffer$ = STRING$(BLft&, 0)'Read what's left
    END IF

    GET File, , Buffer$         'Read from file

    'CalcCRC SSEG(Buffer$), SADD(Buffer$), LEN(Buffer$)  'Pass to lib
' to calc

    BLft& = LOF(File) - LOC(File)'How many more bytes left?

LOOP UNTIL BLft& = 0             'Are we done yet?

SEEK File, FPos&

'CRC$ = HEX$(GetCRC)
'ResetCRC

'Delete the following line after you have unpacked the support lib:
CRC$ = "0"

END FUNCTION

SUB Decode8 (Infile$)

DIM Char(1 TO 6)    AS STRING * 1
DIM Block(1 TO 6)   AS STRING * 8
DIM Shift           AS INTEGER
DIM InBuffer        AS STRING
DIM OutBuffer       AS STRING

InH = FREEFILE
OPEN Infile$ FOR INPUT AS #InH

INPUT #InH, InBuffer
IF InBuffer + "," <> Header8 THEN
        PRINT "Not a BT8 script file"
        EXIT SUB
END IF
INPUT #InH, Outfile$                'Extract filename
INPUT #InH, InBuffer                'Read file size
Size& = VAL("&H" + InBuffer)        'Filesize is stored in hex to save
' space.
INPUT #InH, CrcValue$               'Read file CRC
INPUT #InH, FDate$                  'Read file date
INPUT #InH, FTime$                  'Read file time

FPos = SEEK(InH)

DO
    LINE INPUT #InH, InBuffer
    IF LEFT$(InBuffer, LEN(Footer8)) = Footer8 THEN
        NumBlocks& = VAL("&H" + MID$(InBuffer, LEN(Footer8) + 1))
        Flag = 1
    ELSEIF EOF(InH) THEN
        Flag = 2
    END IF
LOOP UNTIL Flag = 1 OR Flag = 2

IF Flag = 2 THEN
    PRINT "Incompleat script file!"
    EXIT SUB
END IF

SEEK InH, FPos

Flag = 0: FPos = 0

OutH = FREEFILE
OPEN Outfile$ FOR BINARY AS #OutH

DO

    InBuffer = ""

    IF (NumBlocks& - BlockCount&) >= 5 THEN

        FOR BlockIdx = 1 TO 4
            InBuffer = GetChars$(InH, 8, Flag)
            Block(BlockIdx) = MID$(InBuffer, 1, 8)
            BlockCount& = BlockCount& + 1
        NEXT

        InBuffer = GetChars$(InH, 9, Flag)

        Block(BlockIdx) = MID$(InBuffer, 1, 8)
        Shift = ASC(MID$(InBuffer, 9, 1)) - 63
        BlockCount& = BlockCount& + 1
    ELSE
        FOR BlockIdx = 1 TO (NumBlocks& - BlockCount&) - 1
            InBuffer = GetChars$(InH, 8, Flag)
            Block(BlockIdx) = MID$(InBuffer, 1, 8)
            BlockCount& = BlockCount& + 1
        NEXT

        InBuffer = GetChars$(InH, 9, Flag)

        Block(BlockIdx) = MID$(InBuffer, 1, 8)
        Shift = ASC(MID$(InBuffer, 9, 1)) - 63
        BlockCount& = BlockCount& + 1
    END IF

    FOR BlockIdx = 1 TO 5

        Highbits = ASC(MID$(Block(BlockIdx), 7, 1)) + 1
        Upshift = ASC(MID$(Block(BlockIdx), 8, 1)) + 1

        IF Shift AND 2 ^ (BlockIdx - 1) THEN Upshift = Upshift - 34
        IF Upshift AND 2 ^ 6 THEN Highbits = Highbits - 34

        FOR ByteIdx = 1 TO 6

            Char = ASC(MID$(Block(BlockIdx), ByteIdx, 1)) + 1

            IF Upshift AND 2 ^ (ByteIdx - 1) THEN Char = Char - 34
            IF Highbits AND 2 ^ (ByteIdx - 1) THEN Char = Char + 2 ^ 7

            OutBuffer = CHR$(Char)
            PUT #OutH, , OutBuffer
            ByteCount& = ByteCount& + 1

            LOCATE , 1: PRINT "Bytes to go: "; Size& - ByteCount&;

            IF ByteCount& = Size& THEN EXIT DO

            Char = 0

        NEXT
    NEXT

LOOP UNTIL ExitFlag = 1

IF CRC$(OutH) <> CrcValue$ THEN
    PRINT "Bad CRC!"
ELSE
    PRINT "Output file passes CRC check."
END IF

CLOSE #InH, #OutH

Hour = VAL("&H" + LEFT$(FTime$, 2)): Minute = VAL("&H" + MID$(FTime$, 3, 2))
Second = VAL("&H" + MID$(FTime$, 5, 2)): Month = VAL("&H" + MID$(FDate$, 1, 2))
Day = VAL("&H" + MID$(FDate$, 3, 2)): Year = VAL("&H" + MID$(FDate$, 5))

SetFileDateTime Outfile$, Year, Month, Day, Hour, Minute, Day, ECode

END SUB

SUB Encode8 (Infile$, Outfile$)

DIM Char(1 TO 6)                AS STRING * 1
DIM OutBuffer                   AS STRING
DIM BlockBuffer                 AS STRING
DIM BytesLeft                   AS LONG

InH = FREEFILE
OPEN Infile$ FOR BINARY AS #InH
OutH = FREEFILE
OPEN Outfile$ FOR OUTPUT AS #OutH

GetFileDateTime Infile$, FDate$, FTime$, ECode

PRINT #OutH, Header8 + StripName$(Infile$); ","; HEX$(LOF(InH)); ","; CRC$(InH); ","; FDate$; ","; FTime$

DO
    BytesLeft = LOF(InH) - LOC(InH)
    BlockBuffer = ""
    Highbits = 0
    Upshifts = 0

    LOCATE , 1: PRINT "Bytes to go: "; BytesLeft;

    FOR V = 1 TO 6: Char(V) = CHR$(0): NEXT

    IF BytesLeft >= 6 THEN
        FOR V = 1 TO 6: GET #InH, , Char(V): NEXT
    ELSE
        FOR V = 1 TO BytesLeft: GET #InH, , Char(V): NEXT
    END IF

    FOR d = 1 TO 6
        IF ASC(Char(d)) AND 2 ^ 7 THEN
            Highbits = Highbits + 2 ^ (d - 1)
            Char(d) = CHR$(ASC(Char(d)) - 2 ^ 7)
        END IF

        IF ASC(Char(d)) <= 34 THEN
            Upshifts = Upshifts + 2 ^ (d - 1)
            Char(d) = CHR$(ASC(Char(d)) + 34)
        END IF

        Char(d) = CHR$(ASC(Char(d)) - 1)
        BlockBuffer = BlockBuffer + Char(d)
    NEXT

    IF Highbits <= 34 THEN
        Highbits = Highbits + 34
        Upshifts = Upshifts + 2 ^ 6
    END IF

    IF Upshifts <= 34 THEN
        Shift = Shift + 2 ^ ShiftBit
        Upshifts = Upshifts + 34
    END IF

    ShiftBit = ShiftBit + 1

    IF ShiftBit = 5 THEN
        Shift$ = RTRIM$(LTRIM$(CHR$(Shift + 63)))
        ShiftBit = 0
        Shift = 0
    ELSE
        Shift$ = ""
    END IF

    BlockBuffer = BlockBuffer + RTRIM$(LTRIM$(CHR$(Highbits - 1))) + RTRIM$(LTRIM$(CHR$(Upshifts - 1))) + Shift$
    OutBuffer = OutBuffer + BlockBuffer

    NumBlocks& = NumBlocks& + 1

    IF LEN(OutBuffer) = LineLength THEN
        PRINT #OutH, OutBuffer
        OutBuffer = ""
    ELSEIF LEN(OutBuffer) > LineLength THEN
        PRINT #OutH, LEFT$(OutBuffer, 72)
        OutBuffer = MID$(OutBuffer, 73)
    END IF

    REDIM Char(1 TO 6) AS STRING * 1

LOOP UNTIL BytesLeft = 0 OR INKEY$ <> ""

IF ShiftBit <> 0 THEN
    Shift$ = RTRIM$(LTRIM$(CHR$(Shift + 63)))
    ShiftBit = 0
    Shift = 0
ELSE
    Shift$ = ""
END IF

OutBuffer = OutBuffer + Shift$

IF LEN(OutBuffer) <> 0 THEN
    PRINT #OutH, OutBuffer
    OutBuffer = ""
ELSEIF LEN(OutBuffer) > LineLength THEN
    PRINT #OutH, LEFT$(OutBuffer, 72)
    OutBuffer = MID$(OutBuffer, 73)
END IF

PRINT #OutH, Footer8; HEX$(NumBlocks&)

CLOSE #OutH, #InH

END SUB

FUNCTION GetChars$ (Filenumber, Chars, Flag)
FOR X = 1 TO Chars
    DO
        IF NOT EOF(Filenumber) THEN InChar$ = INPUT$(1, Filenumber) ELSE InChar$ = "  ": Flag = 1
        IF InChar$ = CHR$(13) OR InChar$ = CHR$(10) THEN InChar$ = ""
    LOOP UNTIL LEN(InChar$) >= 1
    Buffer$ = Buffer$ + InChar$
NEXT

GetChars$ = Buffer$
END FUNCTION

SUB GetFileDateTime (f$, FileDate$, FileTime$, ECode)
DIM Regs AS RegTypeX

ECode = 0
FileName$ = f$ + CHR$(0)                    ' must be ASCIIZ

Regs.ax = &H3D00                          ' Open file function
Regs.ds = SSEG(FileName$)
Regs.dx = SADD(FileName$)
'CALL InterruptX(&H21, Regs, Regs)      ' Open the file
'Uncomment this call after you have created the support lib.
        IF NOT Regs.flags THEN                   ' No error
                Handle = Regs.ax                     ' Save DOS file
' handle
                Regs.ax = &H5700                      ' Get date/time
                Regs.bx = Handle
                'CALL InterruptX(&H21, Regs, Regs)

                HMS& = Regs.cx                       ' Use long integer
' for
                IF HMS& < 0& THEN HMS& = 65536 + HMS&   ' positive
' numbers
                Hours = (HMS& \ 2048&) AND 31           ' Hours is
' first 5 bits
                Minutes = (HMS& \ 32&) AND 63&          ' Minutes is
' nxt 6 bits
                Seconds = (HMS& AND 31&) * 2            ' Secnds is
' last 5 bits
                h$ = HEX$(Hours): IF LEN(h$) = 1 THEN h$ = "0" + h$
                m$ = HEX$(Minutes): IF LEN(m$) = 1 THEN m$ = "0" + m$
                s$ = HEX$(Seconds): IF LEN(s$) = 1 THEN s$ = "0" + s$
                FileTime$ = h$ + m$ + s$

                YMD& = Regs.dx                       ' Long int here too
                IF YMD& < 0 THEN YMD& = 65536 + YMD&    ' Cnv +
                Year = 1980& + YMD& \ 512&              ' Year is first
' 7 bits
                Month = (YMD& AND 511&) \ 31&           ' Month is next
' 4 bits
                Day = YMD& AND 31&                      ' Day is last 5
' bits
                Y$ = HEX$(Year)
                m$ = HEX$(Month): IF LEN(m$) = 1 THEN m$ = "0" + m$
                d$ = HEX$(Day): IF LEN(d$) = 1 THEN d$ = "0" + d$
                FileDate$ = m$ + d$ + Y$

                Regs.ax = &H3E00                      ' Close file
' function
                Regs.bx = Handle
                'CALL InterruptX(&H21, Regs, Regs)  ' Close it

        ELSE
                ECode = Regs.flags       ' Otherwise return error flags

        END IF

END SUB

SUB SetFileDateTime (f$, xYear, xMonth, xDay, xHour, xMinute, xSecond, ECode)
DIM Regs AS RegTypeX

ECode = 0
FileName$ = f$ + CHR$(0)

Regs.ax = &H3D00
Regs.ds = SSEG(FileName$)
Regs.dx = SADD(FileName$)
'CALL InterruptX(&H21, Regs, Regs)

        IF NOT Regs.flags THEN
                Handle = Regs.ax
                Regs.ax = &H5701
                Regs.bx = Handle

                Hours& = xHour * 2048&
                Minutes& = xMinute * 32&
                Seconds& = xSecond \ 2
                HMS& = Hours& + Minutes& + Seconds&
                IF HMS& > 32767 THEN
                        Regs.cx = HMS& - 65536
                ELSE
                        Regs.cx = HMS&
                END IF

                Year& = (xYear - 1980&) * 512&
                Month& = xMonth * 32&
                Day& = xDay
                YMD& = Year& + Month& + Day&
                IF YMD& > 32767 THEN
                        Regs.dx = YMD& - 65536
                ELSE
                        Regs.dx = YMD&
                END IF

                'CALL InterruptX(&H21, Regs, Regs)

                Regs.ax = &H3E00
                Regs.bx = Handle
                'CALL InterruptX(&H21, Regs, Regs)
        ELSE
                ECode = Regs.flags
        END IF

END SUB

FUNCTION StripName$ (Infile$)
FOR Y = LEN(Infile$) TO 1 STEP -1
        IF MID$(Infile$, Y, 1) = "\" THEN
                StripName$ = UCASE$(MID$(Infile$, Y + 1))
                Flag = 1
                EXIT FOR
        END IF
NEXT
IF Flag <> 1 THEN
        StripName$ = UCASE$(Infile$)
END IF
END FUNCTION

