' Cryptor version 2.0, by Glenn Kinen. In the Public Domain!
' A short, workable demoonstration on encryption in QuickBASIC 4.5.
' Uses XOR encryption. It firsts manipulates the password, so it isn't
' shown in the file. It has extended ability to handle NULs so they reveal
' not the file nor the password. The program is slow, but in all the
' tests I've done with it, not one (Yes, not one!), failed.
' If you try to decrypt it with the wrong password, it will only encrypt
' it even further! Therefore it must be decrypted twice to get the original
' file.
' This is a bit faster than Cryptor 1.12 and back. I'd like to thank
' those people who slapped me around, saying "It speeds up if you DON'T
' DO IT 1 BYTE AT A TIME". (My inspiration for the NumBuffer% Function!)
' Changing the NumBuffer basis past 4096 saved little time.
' I chose that, because it is a common cluster size, either holds 1 cluster
' or two, depending on DOS version. Change it to see the optimal speed on
' your system! Oh BTW, Max file size is two MEGS. I dunno if this is
' true for DOS also. Oh well, tell me.
' Benchmarks:
' CRYPTOR 1.12    CRYPTOR 2.0
' 335 Seconds     125 Seconds             File Size - 100k
' 33 Seconds      13  Seconds             File Size - 10k
' 4 Seconds       1.5 Seconds             File Size - 1k
' Write to Glenn Kinen at MACC BBS for any comments or suggestions.
' (The number is 305-596-1854), or on the QUIK_BAS echo.
' Here's my humble and cheap, and stupid, and... Encryptor.
' No! What makes you think I'm a masochist? <GRIN>

COMMON SHARED file$, KeyText$, Status$    'Put the COMMON status on variables
DECLARE SUB ErrorMsgs ()
DECLARE SUB GetCommand ()
DECLARE SUB XORThePW ()
DECLARE FUNCTION NumBuffer% (ExitStatus%, keepCount&)
ON ERROR GOTO ErrorHandler:
CLS
PRINT "Glenn Kinen's 'Cryptor' version 2.0": PRINT
GetCommand   'Check COMMAND$

SELECT CASE Status$
 CASE "None"
   INPUT "What is the file to be encrypted/decrypted?  ", file$
   file$ = UCASE$(RTRIM$(LTRIM$(file$)))
   LINE INPUT "What is the Key Code?  ", KeyText$
   KeyText$ = LEFT$(LCASE$(LTRIM$(RTRIM$(KeyText$))), 25)
   IF KeyText$ = "" THEN KeyText$ = "put in place password"
 CASE "One"
   LINE INPUT "What is the Key Code?  ", KeyText$
   KeyText$ = LEFT$(LCASE$(LTRIM$(RTRIM$(KeyText$))), 25)
   IF KeyText$ = "" THEN KeyText$ = "put in place password"
END SELECT

IF LEN(file$) = 0 THEN PRINT "Please enter a file then run the program again!": END
IF INSTR(file$, "*") OR INSTR(file$, "?") THEN BEEP: PRINT "Wildcards not permitted!": END

OPEN file$ FOR BINARY AS #1
IF LOF(1) = 0 THEN BEEP: PRINT "File not found!": CLOSE : KILL file$: KILL "CRYPTMP.$$$": END

PRINT : PRINT "Crypting with Key - "; CHR$(34); UCASE$(KeyText$); CHR$(34)
RANDOMIZE (LEN(KeyText$) * LEN(KeyText$)) 'Yea, I wanted to be original!
XORThePW     'Make the password encrypted too
PRINT "The file '"; file$; "' is"; LOF(1); "bytes long.": PRINT
interVal% = LOF(1) \ 100: IF interVal% = 0 THEN interVal% = 1
LOCATE 9: PRINT "Percent Done - 0"
start& = TIMER
DO
Bytes$ = STRING$(NumBuffer%(ExitStatus%, keepCount&), " ")
GET #1, , Bytes$
FOR i% = 1 TO LEN(Bytes$)
keepCount& = keepCount& + 1    'Set counter variables
bit$ = MID$(Bytes$, i%, 1)
 count% = count% + 1
 IF count% > 25 THEN count% = 1
 IF bit$ = "" THEN   'handle NULs in file
  temp% = 0
 ELSE
  temp% = ASC(bit$)
 END IF
 IF MID$(KeyText$, count%, 1) = "" THEN
  temp2% = (count% * INT(RND * 10) + 1 XOR INT(RND * 255) + 1) OR LEN(KeyText$) 'handle NULs
   '(the OR was to get it closer to the High ASCII Character set
   ' and its harder to crack that than standard ASCII, I think!)
 ELSE
  temp2% = ASC(MID$(KeyText$, count%, 1))
 END IF
 MID$(Bytes$, i%, 1) = CHR$(temp% XOR temp2%)
 IF keepCount& MOD interVal% = 0 THEN LOCATE 9, 15: PRINT keepCount& * 100 \ LOF(1)
NEXT i%
  PUT #1, SEEK(1) - LEN(Bytes$), Bytes$
  IF ExitStatus% THEN EXIT DO
  Bytes$ = ""
LOOP
final& = TIMER
elapsed& = final& - start&
LOCATE 9, 16: PRINT "100"
PRINT : PRINT "The Cryption took"; elapsed&; "seconds to complete."
CLOSE
BEEP: PRINT "The Cryption is done! Enjoy!"
END

ErrorHandler:
ErrorMsgs

SUB ErrorMsgs
BEEP
PRINT
SELECT CASE ERR
 CASE 7
  PRINT "Out of memory error!"
 CASE 57
   PRINT "An Device I/O error occured! Odds are the disk is a tad lower than par..."
   PRINT "(Or I made a really BIG boo-boo when I made this program!)"
 CASE 64
   PRINT "Invalid filename! Look in your DOS manual for valid filenames!"
 CASE 71
   PRINT "Disk media error! Consult your DOS manual for details on this error!"
 CASE 70
   PRINT "Permission denied! This error occurs because ... A. You ran this"
   PRINT "on a network and the file is locked, or a file has the Read-Only"
   PRINT "attribute set."
 CASE 71
   PRINT "Disk not ready! Make sure there is a disk in the drive, and"
   PRINT "the drive door is closed!"
 CASE 76
   PRINT "Path not found! Probable Cause: Unexistant or Invalid Directory"
 CASE ELSE
   PRINT "A unknown error occured!"
END SELECT
PRINT : PRINT "Usage:  CRYPTOR [<File> [<Key Code>]]"
END
END SUB

SUB GetCommand

 Comnd$ = RTRIM$(COMMAND$)
 Seperation% = INSTR(Comnd$, " ")    'mark place where commands "seperate"
  
 IF Comnd$ = "" THEN Status$ = "None": EXIT SUB

IF Seperation% = 0 THEN
   file$ = Comnd$
   Status$ = "One"
   EXIT SUB
 ELSE
   file$ = LTRIM$(RTRIM$(LEFT$(Comnd$, Seperation%)))
   KeyText$ = MID$(Comnd$, Seperation% + 1)
   KeyText$ = LTRIM$(RTRIM$(LCASE$(LEFT$(KeyText$, 25))))
 END IF

END SUB

FUNCTION NumBuffer% (ExitStatus%, keepCount&)
  IF LOF(1) - keepCount& > 4096 THEN
   NumBuffer% = 4096
  ELSE
   NumBuffer% = LOF(1) - keepCount&
   ExitStatus% = -1
  END IF
END FUNCTION

SUB XORThePW
 IF LEN(KeyText$) <> 1 THEN
   temporaryVal$ = KeyText$
  
   FOR i% = LEN(KeyText$) TO 1 STEP -1
    temporaryVal2$ = temporaryVal2$ + MID$(KeyText$, i%, 1)
   NEXT i%

   FOR j% = 1 TO LEN(KeyText$)
     temp% = ASC(MID$(temporaryVal$, j%, 1))
     temp2% = ASC(MID$(temporaryVal2$, j%, 1))
     finalTemp% = temp% XOR temp2%
     TempText$ = TempText$ + CHR$(finalTemp%)
   NEXT j%
   IF LEN(TempText$) < 25 THEN
     FOR k% = LEN(TempText$) TO 25     'give everything 25 byte long pw's
      randNum% = INT(RND * 255) + 1
      IF MID$(TempText$, k%, 1) = "" THEN
        part1% = 0
      ELSE
        part1% = ASC(MID$(TempText$, k%, 1))
      END IF
      result% = part1% XOR INT(RND * 255) + 1
      TempText$ = TempText$ + CHR$(result%)
    NEXT k%
   END IF
  KeyText$ = TempText$
  EXIT SUB
END IF
  
  XORed% = ASC(KeyText$)
  KeyText$ = ""
  FOR l% = 1 TO 25
   randNum% = INT(RND * 255) + 1
    KeyText$ = KeyText$ + CHR$(XORed% XOR randNum%)   'Turn 1 byte pw's
  NEXT l%                                             'Into 25 byte pw's
END SUB

