#pragma warn +all

#include <stdio.h>
#include <dos.h>
#include "mcb.h"
#include "bits.h"
#include <string.h>
#include <alloc.h>

#define NORMALISE(fp)       (FP_SEG(fp)+(FP_OFF(fp)>>4))
#define IS_PSP(mcb)         (FP_SEG(mcb)+1==(mcb)->owner)
#define ENV_FM_PSP(psp_seg) (*((word far *)MK_FP((psp_seg), 0x2c)))
#define MCB_FM_SEG(seg)     ((seg)-1)
#define PARENT(psp_seg)     (*((word far *)MK_FP((psp_seg), 0x16)))

// main

int main(void) {
  char far *parent_env, far *rp, far *lcenv, far *rp2, buf[80];
  word envsize, len;
  struct date d;

  getdate(&d);
  sprintf(buf,"DATE=%02.2d%02.2d%02.2d",d.da_year%100,d.da_mon,d.da_day);

  // find the environment of whatever ran us, into master_env

  if((parent_env=(char far *)par_env(&envsize))==NULL) {
    fputs("Error locating parent environment.\n", stderr);
    return 1;
  }

  // allocate enough room for a copy of it.

  if((lcenv=(char far *)farmalloc(envsize*16))==NULL) {
    perror("Error allocating memory for working copy of environment");
    return 1;
  }

  // copy all except DATE=

  rp2=lcenv;

  for(rp=parent_env;*rp;rp=nxtevar(rp))
    if(farstrncmp(rp,(void far *)"DATE=",5)) {
      len=farstrlen(rp);
      farmemcpy(rp2,rp,len+1);
      rp2 += len+1;
    }

  *rp2='\0'; // extra null termination

  // is there enough room to add the new DATE?

  if((word)(rp2-lcenv)+strlen(buf)>=envsize*16)
    fputs("Not enough environment space.\n",stderr);
  else {

    // add the new DATE=

    len=strlen(buf);
    farmemcpy(rp2,(void far *)buf,len+1);
    rp2 += len+1;
    *rp2='\0'; // extra null termination

    // copy the new environment back

    farmemcpy(parent_env,lcenv,envsize*16);
    puts(buf);
  }

  farfree(lcenv);
  return 0;
}

