'DECANSI4.BAS
'Scott M. Pessoni 1995
'
'ANSI DECODER
'If you use this code, please give me credit for what I have done.
'=================================================================
DECLARE SUB CleanUp ()
DECLARE SUB PrintANSI (IN$)
DECLARE SUB GlueDigit ()
DECLARE SUB ColorSORT (NUM!)
DECLARE SUB GETSEQ (OUT$)
DECLARE SUB PrintCHR (prnt$)
DECLARE SUB SendAnsiString (IN$, CR!)
DECLARE SUB PrintString (IN$, CR!)

DIM SHARED FLASH, BOLD, BackNUM, ForNUM, ColorWork
DIM SHARED X, Y, AnsiFLAG, Xsave, Ysave, LINE25$
DIM SHARED DigitNUM, DIGIT1, DIGIT2, DIGIT3, DIGIT4, DIGIT5
DIM SHARED MAKENUM$, DigitSet, Record$, Terminal

'===================== SET-UP =================
SCREEN 0
CLS
X = 1: Y = 1
LINE25$ = "Decode ANSI version 1.4Beta                                   Scott Pessoni 1995"
                    'LINE25$ = Status bar / What ever to stay on screen
Terminal = 1        '1= Send response to [6n   2= Don't send response
BOLD = 0            '1= Bold text    0= Normal
FLASH = 0           '1= Flash text   0= Normal
Xsave = 1           '|
Ysave = 1           '| Default saved location
ForNUM = 7          'Current color on screen
BackNUM = 0         'Current Back color on screen
PrintCHR CHR$(12)   'Clear the screen with everything set

'===================================================
'This Example will display a ANSI file.
'----------------------------------------
'This program can easily be modified for displaying
'the local side of a door.
'This is probably not the fastest way of displaying ansi
'But it works.  The speed of this program might be a problem
'for high speed modems, but when compiled it will work faster.
'This should decode all ansi escape codes in your DOS book
'except character remaping and screen mode changing.
'
'--------------------------------------------------------------
CLS : COLOR 7: PRINT "Enter a ANSI file to display:";
COLOR 3: INPUT "", AnsiFile$
PrintCHR CHR$(12)

OPEN AnsiFile$ FOR INPUT AS #1

DO
     LINE INPUT #1, IN$
     SendAnsiString IN$, 1
LOOP UNTIL EOF(1) = -1

END

'CleanUp
'    This SUB clears all flags and sets varibles at it's set number.
'
'============================================================================
SUB CleanUp
AnsiFLAG = 0
DigitSet = 0
DigitNUM = 0
DIGIT1 = -1: DIGIT2 = -1: DIGIT3 = -1: DIGIT4 = -1: DIGIT5 = -1
MAKENUM$ = ""
Record$ = ""
END SUB

'ColorSORT AnsiColorNumber
'    -This SUB sorts out all ANSI COLOR code numbers to come out with a
'     common color number.
'
'
SUB ColorSORT (NUM)
'============================================================================
SELECT CASE NUM

' MISC VIDEO
CASE 0
        BOLD = 0
        ColorWork = 7
        BackNUM = 0
        FLASH = 0
CASE 1
        BOLD = 1

CASE 5
        FLASH = 1

' FORGROUND COLORS
CASE 30
        ColorWork = 0
CASE 31
        ColorWork = 4
CASE 32
        ColorWork = 2
CASE 33
        ColorWork = 6
CASE 34
        ColorWork = 1
CASE 35
        ColorWork = 5
CASE 36
        ColorWork = 3
CASE 37
        ColorWork = 7

' Background Colors
CASE 40
        BackNUM = 0
CASE 41
        BackNUM = 4
CASE 42
        BackNUM = 2
CASE 43
        BackNUM = 6
CASE 44
        BackNUM = 1
CASE 45
        BackNUM = 5
CASE 46
        BackNUM = 3
CASE 47
        BackNUM = 7
END SELECT

END SUB

'GETSEQ
'     -This SUB scans all ANSI escape codes until it reaches the control
'      letter. It also builts up the numbers in banks DIGIT1 through DIGIT2
'      If there is a character that should not be in the sequnce, it will
'      abort the sequence.
'
SUB GETSEQ (OUT$)
'============================================================================
SELECT CASE OUT$
            
     CASE ";"  'A conector that says there is going to be another number.
          'Same as GlueDigit ==>
          DigitSet = DigitSet + 1
          IF DigitSet = 1 THEN DIGIT1 = VAL(MAKENUM$)
          IF DigitSet = 2 THEN DIGIT2 = VAL(MAKENUM$)
          IF DigitSet = 3 THEN DIGIT3 = VAL(MAKENUM$)
          IF DigitSet = 4 THEN DIGIT4 = VAL(MAKENUM$)
          IF DigitSet = 5 THEN DIGIT5 = VAL(MAKENUM$)
          MAKENUM$ = ""
          Record$ = Record$ + ";"  'Add to Recorder
          EXIT SUB
           
     CASE "m"  'Change color
          GlueDigit
          'Sort colors for all DIGITs
          FOR DigitColorLoop = 1 TO DigitSet
               IF DigitColorLoop = 1 THEN ColorSORT DIGIT1
               IF DigitColorLoop = 2 THEN ColorSORT DIGIT2
               IF DigitColorLoop = 3 THEN ColorSORT DIGIT3
               IF DigitColorLoop = 4 THEN ColorSORT DIGIT4
               IF DigitColorLoop = 5 THEN ColorSORT DIGIT5
          NEXT DigitColorLoop
         
          ForNUM = ColorWork
          'Set Attributes
          IF BOLD = 1 THEN ForNUM = ForNUM + 8
          IF FLASH = 1 THEN ForNUM = ForNUM + 16
          COLOR ForNUM, BackNUM
          CleanUp
          EXIT SUB
    
     CASE "J"  'Clear Screen
          GlueDigit
          CLS
          X = 1
          Y = 1
          COLOR 7, 1
          LOCATE 25, 1: PRINT LINE25$;
          COLOR ForNUM, BackNUM
          LOCATE Y, X
          CleanUp
          EXIT SUB

     CASE "H"  'Locate screen cursor
          GlueDigit
          IF DIGIT1 AND DIGIT2 = -1 THEN X = 1: Y = 1
          IF DIGIT1 > 0 AND DIGIT2 = -1 THEN X = 1: Y = DIGIT1
          IF DIGIT1 > 0 AND DIGIT2 > 0 THEN X = DIGIT2: Y = DIGIT1

          IF Y >= 25 THEN Y = 24
          IF Y < 1 THEN Y = 1

          IF X >= 81 THEN X = 80
          IF X < 1 THEN X = 1

          LOCATE Y, X
          CleanUp
          EXIT SUB
               
     CASE "F"  'Same as above - Locate cursor
          GlueDigit
          IF DIGIT1 AND DIGIT2 = -1 THEN X = 1: Y = 1
          IF DIGIT1 > 0 AND DIGIT2 = -1 THEN X = 1: Y = DIGIT1
          IF DIGIT1 > 0 AND DIGIT2 > 0 THEN X = DIGIT2: Y = DIGIT1

          IF Y >= 25 THEN Y = 24
          IF Y < 1 THEN Y = 1

          IF X >= 81 THEN X = 80
          IF X < 1 THEN X = 1

          LOCATE Y, X
          CleanUp
          EXIT SUB

     CASE "A"  'Move Cursor up
          GlueDigit
          IF DIGIT1 = -1 THEN
               Y = Y - 1
               IF Y <= 0 THEN Y = 1
          ELSE
               Y = Y - DIGIT1
               IF Y <= 0 THEN Y = 1
          END IF

          LOCATE Y, X
          CleanUp
          EXIT SUB

     CASE "B"  'Move cursor down
          GlueDigit
          IF DIGIT1 = -1 THEN
               Y = Y + 1
               IF Y >= 25 THEN Y = 24
          ELSE
               Y = Y + DIGIT1
               IF Y >= 25 THEN Y = 24
          END IF

          LOCATE Y, X
          CleanUp
          EXIT SUB

     CASE "C"  'Move Cursor forward
          GlueDigit
          IF DIGIT1 = -1 THEN
               X = 1 + X
          ELSE
               X = DIGIT1 + X
          END IF
          IF X >= 81 THEN X = 80

          LOCATE Y, X
          CleanUp
          EXIT SUB
               
     CASE "D"  'Move cursor backwards
          GlueDigit
          IF DIGIT1 = -1 THEN
               X = X - 1
          ELSE
               X = X - DIGIT1
          END IF
          IF X <= 0 THEN X = 1

          LOCATE Y, X
          CleanUp
          EXIT SUB

     CASE "s"  'Save cursor position
          GlueDigit
          Xsave = X
          Ysave = Y
          CleanUp
          EXIT SUB
               
     CASE "u"  'Restore save cursor postion
          GlueDigit
          X = Xsave
          Y = Ysave
          LOCATE Y, X
          CleanUp
          EXIT SUB

     CASE "K"  'Delete until end of line
          GlueDigit

          FOR DELLINE = X TO 80
               LOCATE Y, DELLINE: PRINT " ";
          NEXT DELLINE

          LOCATE Y, X
          CleanUp
          EXIT SUB

     CASE "n"  'Device Status Report(Sent from remote computer to detect ANSI)
          GlueDigit
          IF DIGIT1 = 6 THEN
               IF Terminal = 1 THEN
                    'If your using this program as a terminal.
                    '*****> Change TRANSMIT to what you use to send data out!
                    'TRANSMIT CHR$(27) + "[" + STR$(Y) + ";" + STR$(X) + "R"
                    '******* NOTICE THERE IS NO ";" AT THE END! (No CR/LF)
               END IF
          END IF
         
          CleanUp
          EXIT SUB
     
     CASE ELSE '> If not a ANSI end token
          MAKENUM$ = MAKENUM$ + OUT$    'Builds up Numbers until ";" or
                                        'it gets to a ANSI token.

          Record$ = Record$ + OUT$      'Build up RECORD incase sequence
                                        'gets bad.
         
          '************** Check for false Escape code ****
          IF ASC(OUT$) < 48 OR ASC(OUT$) > 57 THEN
               'PrintCHR OUT$
               'BEEP
               PrintString CHR$(27) + "[" + Record$, 0
               CleanUp
          END IF
END SELECT

END SUB

'GlueDigit
'    This SUB makes stores numbers in DIGIT1 through DIGIT5
SUB GlueDigit
IF LEN(MAKENUM$) > 0 THEN
     DigitSet = DigitSet + 1
     IF DigitSet = 1 THEN DIGIT1 = VAL(MAKENUM$)
     IF DigitSet = 2 THEN DIGIT2 = VAL(MAKENUM$)
     IF DigitSet = 3 THEN DIGIT3 = VAL(MAKENUM$)
     IF DigitSet = 4 THEN DIGIT4 = VAL(MAKENUM$)
     IF DigitSet = 5 THEN DIGIT5 = VAL(MAKENUM$)
     MAKENUM$ = ""
END IF
END SUB

'PrintANSI OneChrIn$
'    -This sub checks for ANSI Escape Seqences
'
SUB PrintANSI (IN$)
'============================================================================
       
IF AnsiFLAG = 2 THEN GETSEQ IN$: EXIT SUB
       
IF AnsiFLAG = 1 THEN
     IF IN$ = "[" THEN
          AnsiFLAG = 2
          EXIT SUB
     ELSE
          'Abort sequence if not correct
          PrintCHR CHR$(27): PrintCHR IN$
          AnsiFLAG = 0
          EXIT SUB
     END IF
END IF
       
IF IN$ = CHR$(27) THEN
     AnsiFLAG = 1
     EXIT SUB
ELSE
     'Print charactor if not in sequence.
     PrintCHR IN$
END IF

END SUB

'PrintCHR OneCharWithNoANSI$
'    This SUB prints one charactor directly to the screen that has NO ANSI
'    in it.
'
'
SUB PrintCHR (prnt$)
'============================================================================
'***************** Check for Control codes ********
SELECT CASE prnt$
CASE CHR$(0)                             'Recived NULL
        EXIT SUB

CASE CHR$(13)
        X = 1                            'Recived CR
        ControlFlag = 1

CASE CHR$(10)
        Y = Y + 1                        'Recived LF
        ControlFlag = 1
     
CASE CHR$(7)
        SOUND 2000, 1.5                  'Recived BELL
        ControlFlag = 1
     
CASE CHR$(8)                             'Recived Backspace
        X = X - 1
        IF X = 0 THEN X = 80: Y = Y - 1
                IF Y = 0 THEN Y = 1: X = 1
        LOCATE Y, X: PRINT " ";
        LOCATE Y, X
        ControlFlag = 1
     
CASE CHR$(9)                                'Recived TAB
        X = X + 8
        IF X > 81 THEN
                X = 1
                Y = Y + 1
        END IF
        ControlFlag = 1
     
CASE CHR$(12)                  'Recived Clear Screen
        COLOR , 0
        CLS
        X = 1
        Y = 1
        COLOR 7, 1
        LOCATE 25, 1: PRINT LINE25$;
        COLOR ForNUM, BackNUM
        LOCATE Y, X
        ControlFlag = 1
     
END SELECT

'************ Print to Screen, If control code, then ONLY update screen ****
IF ControlFlag = 0 THEN
        '******* Main Screen write *****
        LOCATE Y, X
        X = X + 1
        PRINT prnt$;
        '*******************************
END IF

'*************** Update Screen **************
IF X >= 81 THEN                         'Is cursor past 80?
        Y = Y + 1                       'If it is then CR/LF
        X = 1
        IF Y = 25 THEN
               LOCATE 24, X
        ELSE
               LOCATE Y, X
        END IF
END IF

IF Y = 25 THEN                          'Is cursor at line 25?
        PRINT                           'If it is then LF
        Y = 24
END IF
LOCATE Y, X
'********************************************
END SUB

'PrintString StringWithNoANSI$, CR
'    This sub is Identical to PrintAnsiString but does not handle ANSI
'
SUB PrintString (IN$, CR)
'============================================================================
FOR Breakline = 1 TO LEN(IN$)
     PrintCHR MID$(IN$, Breakline, 1)
NEXT Breakline

IF CR = 1 THEN
     PrintCHR CHR$(13)
     PrintCHR CHR$(10)
END IF

END SUB

'SendAnsiString StringWithANSI$, CR
'Send a string of text with or with out ANSI in it
'       StringWithANSI$ = String with ANSI codes
'       CR = 1 add CR/LF  0 no CR/LF
'       -Example SENDANSISTRING "Test one two three!!!", 1
'       -Example SENGANSISTRING CHR$(27) + "2J",0      <- Screen will clear
'       
'
SUB SendAnsiString (IN$, CR)

FOR Breakline = 1 TO LEN(IN$)
     PrintANSI MID$(IN$, Breakline, 1)
NEXT Breakline

IF CR = 1 THEN
     PrintCHR CHR$(13)
     PrintCHR CHR$(10)
END IF
END SUB

