'***  Demonstrates use of FindFirst, FindNext, and Dta DOS SERVICES
'***  Interrupt 21h.
'***
'***  Command line for QB 4.X:
'***
'***       QB DIR5 /L QB
'***

DEFINT A-Z


    TYPE RegTypeX
	 ax    AS INTEGER
	 bx    AS INTEGER
	 cx    AS INTEGER
	 dx    AS INTEGER
	 bp    AS INTEGER
	 si    AS INTEGER
	 di    AS INTEGER
	 flags AS INTEGER
	 ds    AS INTEGER
	 es    AS INTEGER
    END TYPE

    TYPE Dta
	 DosJunk      AS STRING * 21
	 Attr         AS STRING * 1
	 Time         AS INTEGER
	 Date         AS INTEGER
	 Size         AS LONG
	 FileName     AS STRING * 13
    END TYPE


    DECLARE SUB InterruptX (Intnum, InRegs AS RegTypeX, OutRegs AS RegTypeX)
    DECLARE SUB Find5 (Start, Spec$)
'************************************************************
    DIM SHARED Regs AS RegTypeX         'We use Regs for both InRegs & OutRegs
    DIM SHARED Buffer AS Dta            'Holding area for file info
    DIM SHARED Direc(1024) AS STRING * 39
'************************************************************
    COMMON SHARED FileCount, PathNum, Totbytes&
    COMMON SHARED MaxDirEntry, Attr, DateTime$
'************** Set DTA Buffer to hold file info ***********
Start:
    CLS
    Regs.ax = &H1A00
    Regs.ds = VARSEG(Buffer)
    Regs.dx = VARPTR(Buffer)
    CALL InterruptX(&H21, Regs, Regs)   'Set DTA Buffer
    MaxDirEntry = 1024
    DateTime$ = " yy-mm-dd hh:mm"       'Used to format date+time
'************** Get Vol and Directories first ***************
    'Normal    =  0
    'Volume    =  8
    'Directory = 16
    '---------   --
    Attr = 24                 'We filter Normal(0) by AND'ing with 24 in Find5
    Spec$ = "*.*"
    Start = 0
    PathNum = 0               'Tells Find5 we want Vol/Dir only
    CALL Find5(Start, Spec$)
'************** Now the files********************************
    'Normal    =  0
    'Read Only =  1
    'Hidden    =  2
    'System    =  4
    'Archive   = 32
    '---------   --
    Attr = 39
    Start = FileCount
    PathNum = 1                     'Tells Find5 all files
    CALL Find5(Start, Spec$)
'**********************************************
    COLOR 15, 0
    Start = 1
PrintMore:
    PRINT "FileName.Ext  Size  yy-mm-dd hh:mm Attr"
    PRINT "------------ ------ -------- ----- ----"

    FOR I = Start TO Start + 19
    IF I > FileCount THEN
       PRINT
       PRINT FileCount; " Files occupying "; Totbytes&; " bytes"
       END
    END IF
       PRINT Direc(I)
    NEXT
    PRINT
    PRINT " Strike any key for more";
    DO WHILE INKEY$ = "": LOOP
    Start = I
    CLS
    GOTO PrintMore

SUB Find5 (Start, Spec$)
	Counter = Start
	Operation = 1
	'*********** use Int 21 FindFirst_FindNext *****************
MoreFiles:
	IF Operation THEN                     'Set up for FindFirst
	   DIM DateTime(6)
	   Regs.ax = &H4E00
	   Regs.cx = Attr
	   Spec$ = Spec$ + CHR$(0)
	   Regs.ds = VARSEG(Spec$)
	   Regs.dx = SADD(Spec$)
	   Operation = 0
	ELSE
	   Regs.ax = &H4F00                   'Only requirement for FindNext
	END IF
	CALL InterruptX(&H21, Regs, Regs)
	Ecode = Regs.ax
	IF Ecode GOTO Handler5
	Attr = ASC(Buffer.Attr)
	IF PathNum = 0 THEN                            'Only Vol and Subdirs
	   IF (Attr AND 24) = 0 THEN GOTO MoreFiles    'Filter out 0 (Normal)
	END IF
	'************** Calculate date and time *************
	DateTime(1) = Buffer.Date \ 512 + 1980                 'Year
	DateTime(2) = (Buffer.Date \ 32) AND &HF               'Month
	DateTime(3) = Buffer.Date AND &H1F                     'Day
	Hour& = Buffer.Time
	IF Buffer.Time < 0 THEN Hour& = Hour& + 65536
	DateTime(4) = (Hour& AND &HF800) \ 2048                'Hour
	DateTime(5) = (Buffer.Time AND &H7E0) \ 32             'Minutes
	'**** Format w/leading zeroes and stuff DateTime$ ****
	FOR I = 1 TO 5
	   MID$(DateTime$, I * 3 - 1, 2) = RIGHT$(STR$(DateTime(I) + 100), 2)
	NEXT
	'***************************************************
	F$ = Buffer.FileName
	Null = INSTR(F$, CHR$(0))
	IF Null THEN
	   F$ = LEFT$(F$, Null - 1)
	END IF
     IF F$ = "." OR F$ = ".." THEN
	Name$ = LEFT$(F$ + SPACE$(12), 12)
	FileSize$ = SPACE$(7)
	GOTO SkipFormat                    ' Skip filename formatting
     END IF
	N = INSTR(F$, ".")
	IF N THEN
	   Name$ = SPACE$(12)
	   MID$(Name$, 1, N - 1) = LEFT$(F$, N - 1)
	   MID$(Name$, 9) = MID$(F$, N)
	ELSE
	   Name$ = LEFT$(F$ + SPACE$(12), 12)
	END IF
   SELECT CASE Buffer.Size
      CASE IS <= 9999999
	 FileSize$ = SPACE$(7)
	 RSET FileSize$ = LTRIM$(STR$(Buffer.Size))
      CASE IS <= 1023998976
	 FileSize$ = RIGHT$("      " + STR$(Buffer.Size \ 1024), 6) + "K"
      CASE ELSE
	 FileSize$ = RIGHT$("      " + STR$(Buffer.Size \ 1048576), 6) + "M"
   END SELECT
SkipFormat:
IF Counter < MaxDirEntry THEN
   Counter = Counter + 1
ELSE
   FileCount = Counter
   EXIT SUB
END IF
Attr$ = "....."
IF (Attr AND 32) = 32 THEN MID$(Attr$, 4, 1) = "A"
IF (Attr AND 4) = 4 THEN MID$(Attr$, 3, 1) = "S"
IF (Attr AND 2) = 2 THEN MID$(Attr$, 2, 1) = "H"
IF (Attr AND 1) = 1 THEN MID$(Attr$, 1, 1) = "R"
IF (Attr AND 16) = 16 THEN
    MID$(Attr$, 5, 1) = "D"
    FileSize$ = " <DIR> "
ELSE
    Totbytes& = Totbytes& + Buffer.Size       'BYTE TOTAL OF FILES ONLY
END IF
'===========================================================================
ImDone5:
    Direc(Counter) = Name$ + FileSize$ + DateTime$ + Attr$
IF (Attr AND 8) = 8 THEN
   MID$(Direc(Counter), 39, 1) = "V"
   MID$(Direc(Counter), 1, 19) = LEFT$(Name$, 8) + MID$(Name$, 10, 3) + "  volume"
END IF
GOTO MoreFiles                    'Do it again
Handler5:
	IF Ecode = 2 OR Ecode = 18 THEN    'Success
	   FileCount = Counter
	ELSE
	   PRINT " Error "; Ecode; " in Sub Find5.";
	END IF
END SUB

