; FadeToBlackVGA released into the public domain 1993
; Written by Raymond C. Keith
; Compuserve 72212,734
; Fidonet 1:105/224
;
; FadeToBlackVGA will fade the vga color registers 0-15 to black in 5%
; increments.
;
; Notes
; ------------------------------------------------------------------------
; (1) Written with MASM 6.0 to be called from MS PDS BASIC 7.1
; (2) RGBColors%() holds the red/green/blue intensities for the 16 color
;     registers. Intensity is in the range of 0-63
; (3) The PEL address write register will automagicly increment to the
;     next color register address each time 3 intensities have been
;     written to the PEL data register.
; (4) Waiting for a vertical retrace before updating colors is done to
;     keep the fade clean and slow it down a bit.
;
; DECLARE FadeToBlackVGA (BYVAL RGBSeg%, BYVAL RGBAddr%)
; REDIM RGBColors%(0 to 47)
;
; RGBSeg% = VARSEG(RGBColors%(0))
; RGBAddr% = VARPTR(RGBColors%(0))
; CALL FadeToBlackVGA (BYVAL RGBSeg%, BYVAL RGBAddr%)
 
.MODEL MEDIUM,BASIC
.CODE
 
FadeToBlackVGA Proc Uses AX BX CX DX DS SI, RGBSeg:Word, RGBAddr:Word
         mov  bx, RGBSeg     ;data segment of RGBColors%()
         mov  ds, bx
         mov  bx, 100        ;new color will be bx percent of original color
MainFade:
         sub  bx, 5          ;start with 95% and fade to 0% by 5% increments
         push bx             ;save our percent value for later use
         mov  dx, 03DAh      ;read port for vga input status #1 register
VRStart:
         In   al, dx         ;read the above port
         Test al, 8          ;test vertical retrace bit for retrace period
         Jz   VRStart        ;if not in a retrace continue testing
         mov  si, RGBAddr    ;si to first RGBColors%() element
         mov  al, 0000h      ;start with color register 0 of 0-15
         mov  dx, 03C8h      ;PEL address write register port
         OUT  dx, al         ;init register to address of color register 0
         mov  cx, 48         ;total red/grn/blu colors to fade 0-15 * 3
FadeRGB:
         mov  ax, [si]       ;load original color from RGBColors%()
         pop  bx             ;pop the percent value back into bx
         mul  bx             ;bx * ax (percent * original color)
         push bx             ;percent value will be needed again so save it
         mov  bx, 100        ;multiplied by whole numbers so now divide by
         div  bl             ;100 and leave the faded color in al
         mov  dx, 03C9h      ;PEL data register port
         OUT  dx, al         ;out the faded color to PEL data register
         add  si, 2          ;next RGBColors%() element
         loop FadeRGB        ;fade red/grn/blu for colors 0-15
         pop  bx             ;get our percent value again
         cmp  bx, 0          ;compare it to 0
         jg   MainFade       ;if greater than 0 keep fading
    Ret
FadeToBlackVGA Endp
End
