; file:   fastprn.asm 
;         by:   Tom Kiehl 
;               PO Box 693 
;               Indian Rocks Beach, FL 34635 
;       
DGROUP  group   _DATA 
_DATA   segment word public  'DATA'
        assume  ds:DGROUP
monoseg dw      0b000h      ;mono monitor 
colrseg dw      0b800h      ;color monitor

_DATA   ends

PRN_TEXT      segment para public 'CODE'
        assume cs:PRN_TEXT
        public  fastprint

; DECLARE fastprint (BYVAL row%, BYVAL col%, thestring$, BYVAL att%)

        fastprint proc far
        row     equ     <12[bp]>
        col     equ     <10[bp]>
        string  equ     <8[bp]>
        att     equ     <6[bp]>

        push    bp
        mov     bp,sp                   ;set up stack
        push    si                      ;save these
        push    di
        mov     bx,monoseg              ;assume mono
        xor     ax,ax                   ;make it a zero
        mov     es,ax                   ;page 0
        cmp     byte ptr ES:[0463h],0B4h;see what video card is active
        je      nocolor                 ;skip ahead if a match (MONO)
        mov     bx,colrseg              ;color segment if no match (no snow checking) 
nocolor:
        mov     es,bx                   ;screen segment into ES (destination)
        mov     ax,row                  ;get row
        dec     ax                      ;zero base it
        mov     bx,160                  ;160 bytes per 80 col line
        mul     bx                      ;multiply it
        mov     bx,col                  ;get cols
        dec     bx                      ;zero base it
        sal     bx,1                    ;times 2 (2 bytes per column)
        add     ax,bx                   ;total the offset
        mov     di,ax                   ;destination index = offset
        cld                             ;just to make sure increment
        mov     si,string               ;get string descriptor
        mov     cx,[si]                 ;length into cx reg
        jcxz    nullstring              ;bail out of nul string
        mov     si,2[si]                ;address offset of string
        mov     ah,byte ptr att         ;put attribute in ah 
putcharatt:                             ;loop top
        lodsb                           ;get a char from string
        stosw                           ;put both bytes to the screen
        loop    putcharatt              ;loop until done 
nullstring:                             ;clean up duty!
        pop     di
        pop     si
        pop     bp
        ret     8
fastprint       endp
PRN_TEXT        ends
        end

