DEFINT A-Z: '$DYNAMIC
DECLARE SUB FastSortI (Lower AS INTEGER, Upper AS INTEGER)
DECLARE SUB QuickSort (Low AS INTEGER, High AS INTEGER)
DECLARE SUB QuickSort2 (Lower AS INTEGER, Upper AS INTEGER)

TYPE stacktype 'for QuickSort2
   Low AS INTEGER
   Hi AS INTEGER
END TYPE

DIM SHARED Array(1) AS INTEGER
' This is an extreamly fast sorting algorithm so I decided
' to call it FastSort.  ;-)  This is faster than any sort
' algorithm I have ever seen.  It is even a little faster
' than the algorithm created by Dave Cooper.  Mine takes
' .5 seconds less time to sort 16383 entries on a 386 40
' [compiled].  From 8 seconds down to 7.5 seconds.  I know,
' I know a .5 second difference to sort 16383 entries BIG
' WOOP!!  But on a 286/12 it would expand to about a 2 whole
' second difference.  ;-)

ON KEY(10) GOSUB ABORT: : KEY(10) ON

MaxTime = 10

CLS : PRINT "Entries        QuickSort    FastSortI   QuickSort2"
FOR A = 1 TO 14
  
   Count = 2 ^ A
   PRINT Count;
   FLAG = -1

   REDIM Array(1 TO Count) AS INTEGER
  
   IF E1# - S1# < MaxTime THEN
      GOSUB MAKERANDOM:
      S1# = TIMER
      QuickSort 1, Count
      E1# = TIMER
   END IF

   IF E2# - S2# < MaxTime THEN
      GOSUB MAKERANDOM:
      S2# = TIMER
      FastSortI 1, Count
      E2# = TIMER
   END IF

   IF E3# - S3# < MaxTime THEN
      GOSUB MAKERANDOM:
      S3# = TIMER
      QuickSort2 1, Count
      E3# = TIMER
   END IF
  
   T1# = E1# - S1#
   T2# = E2# - S2#
   T3# = E3# - S3#

   LOCATE , 1: PRINT USING "#####          ###.###     ###.###     ###.###"; Count; E1# - S1#; E2# - S2#; E3# - S3#
NEXT A

PRINT
PRINT "QuickSort  - Supplied by MicroSoft Corp. in SORTDEMO.BAS that comes with QB"
PRINT "FastSortI  - Writen by Ryan Wellman.  Released as Freeware October 22, 1992."
PRINT "QuickSort2 - QuickSort iterative (rather than recursive) by Cornel Huth."
SYSTEM

MAKERANDOM:
PRINT ".";
RANDOMIZE A
FOR B = 1 TO Count
   Array(B) = RND * 32766 + 1
NEXT B
RETURN

ABORT:
PRINT "Aborted!"
SYSTEM

REM $STATIC
SUB FastSortI (Lower AS INTEGER, Upper AS INTEGER)

' This routine was writen by Ryan Wellman.
' Copyright 1992, Ryan Wellman, all rights reserved.
' Released as Freeware October 22, 1992.
' You may freely use, copy & modify this code as you see
' fit.  Under the condition that I am given credit for
' the original sort routine, and partial credit for modifided
' versions of the routine.

' Thanks to Richard Vannoy who gave me the idea to compare
' entries further than 1 entry away.

Increment = (Upper + Lower)
L2 = Lower - 1

DO
   ' The Increment variable is used to check how far apart the
   ' program will check.  Also cut the size of increment in half
   ' to decrese Increment which makes the sorted array more
   ' accurate.

   Increment = Increment \ 2
   I2 = Increment + L2

   ' Step through the array 1 element at a time and compare the
   ' elements 'Increment' entries away.

   FOR Index = Lower TO Upper - Increment
      IF Array(Index) > Array(Index + Increment) THEN
         SWAP Array(Index), Array(Index + Increment)

         ' If the the current pointer for Index is greater
         ' than Increment then step back by increment - 1
         ' so that the variable can be put as close as it
         ' can get to it's final point.

         IF Index > I2 THEN

            ' Store a pointer to the curent position so
            ' that it can be restored when this entry is
            ' in it's place.  Causes it to run over 10
            ' times faster on large random arrays.  If
            ' CutPoint has a value then set a new one.

            CutPoint = Index
            StopNow = 0
            DO
               Index = Index - Increment
               IF Array(Index) > Array(Index + Increment) THEN
                  SWAP Array(Index), Array(Index + Increment)

                  ' Reduce the array pointer so that you can slide
                  ' the current number almost to it's finished
                  ' position.

               ELSE
                  StopNow = -1
                  Index = CutPoint
               END IF
            LOOP UNTIL StopNow

            ' Reduce the array pointer so that you can slide
            ' the current number almost to it's finished
            ' position.

         END IF
      END IF
   NEXT Index

LOOP UNTIL Increment <= 1

END SUB

SUB QuickSort (Low AS INTEGER, High AS INTEGER)
' ============================== QuickSort ===================================
'   QuickSort works by picking a random "pivot" element in SortArray, then
'   moving every element that is bigger to one side of the pivot, and every
'   element that is smaller to the other side.  QuickSort is then called
'   recursively with the two subdivisions created by the pivot.  Once the
'   number of elements in a subdivision reaches two, the recursive calls end
'   and the array is sorted.
' ============================================================================

   IF Low < High THEN

      ' Only two elements in this subdivision; swap them if they are out of
      ' order, then end recursive calls:
      IF High - Low = 1 THEN
         IF Array(Low) > Array(High) THEN
            SWAP Array(Low), Array(High)
         END IF
      ELSE

         ' Pick a pivot element at random, then move it to the end:
         RandIndex = INT(RND * (High - Low + 1)) + Low
         SWAP Array(High), Array(RandIndex)
         Partition = Array(High)
         DO

            ' Move in from both sides towards the pivot element:
            i = Low: j = High
            DO WHILE (i < j) AND (Array(i) <= Partition)
               i = i + 1
            LOOP
            DO WHILE (j > i) AND (Array(j) >= Partition)
               j = j - 1
            LOOP

            ' If we haven't reached the pivot element, it means that two
            ' elements on either side are out of order, so swap them:
            IF i < j THEN
               SWAP Array(i), Array(j)
            END IF
         LOOP WHILE i < j

         ' Move the pivot element back to its proper place in the array:
         SWAP Array(i), Array(High)

         ' Recursively call the QuickSort procedure (pass the smaller
         ' subdivision first to use less stack space):
         IF (i - Low) < (High - i) THEN
            QuickSort Low, i - 1
            QuickSort i + 1, High
         ELSE
            QuickSort i + 1, High
            QuickSort Low, i - 1
         END IF
      END IF
   END IF
END SUB

SUB QuickSort2 (Lower%, Upper%)
  'QuickSort iterative (rather than recursive) by Cornel Huth
  DIM LStack(1 TO 128) AS stacktype 'our stack
  DIM SP AS INTEGER 'out stack pointer
  SP = 1
  'maxsp = sp
  LStack(SP).Low = Lower%
  LStack(SP).Hi = Upper%
  SP = SP + 1
  DO
    SP = SP - 1
    Low = LStack(SP).Low
    Hi = LStack(SP).Hi
    DO
      i = Low
      j = Hi
      mid = (Low + Hi) \ 2
      compare = Array(mid)
      DO
        DO WHILE Array(i) < compare
          i = i + 1
        LOOP
        DO WHILE Array(j) > compare
          j = j - 1
        LOOP
        IF i <= j THEN
          SWAP Array(i), Array(j)
          i = i + 1
          j = j - 1
        END IF
      LOOP WHILE i <= j
      IF j - Low < Hi - i THEN
        IF i < Hi THEN
          LStack(SP).Low = i
          LStack(SP).Hi = Hi
          SP = SP + 1
        END IF
        Hi = j
      ELSE
        IF Low < j THEN
          LStack(SP).Low = Low
          LStack(SP).Hi = j
          SP = SP + 1
        END IF
        Low = i
      END IF
    LOOP WHILE Low < Hi
    'IF sp > maxsp THEN maxsp = sp
  LOOP WHILE SP <> 1
  'PRINT "MAX SP"; maxsp
END SUB

