DEFINT A-Z
'$DYNAMIC
DECLARE FUNCTION Convert2FidoText$ (Text$, AreaName$)
DECLARE FUNCTION ConvertChars$ (Text$, Char1 AS STRING, Char2 AS STRING)
DECLARE FUNCTION StripHighASCII$ (Text$)
DECLARE FUNCTION StripControlCodes$ (Text$)
DECLARE FUNCTION AddSeenBy$ (Text$, Address$)
DECLARE FUNCTION AddPath$ (Text$, Address$)
DECLARE FUNCTION AddOrigin$ (Text$, Signature$, Address$)
DECLARE FUNCTION AddTearLine$ (Text$)
DECLARE FUNCTION AddEchoInfo$ (Text$, AreaName$)

REM $STATIC
FUNCTION AddEchoInfo$ (Text$, AreaName$)
   Body$ = Text$
   'We still need the control info
   AreaLine$ = "AREA: " + AreaName$ + CHR$(13)  'Create the AREA: line
   Body$ = AddTearLine$(Body$)               'Add a tear-line if it doesn't
   'Add an origin, if it doesn't have one
   Body$ = AddOrigin$(Body$, "Was a QWK.  Now it's a PKT!", "1:105/330.3")
   Body$ = AddSeenBy(Body$, "105/330")       'Add a SEEN-BY:  if it doesn't
   Body$ = AddPath(Body$, "105/330")         'Add a PATH:  if it doesn't
   AddEchoInfo$ = AreaLine$ + Body$ + CHR$(0)
END FUNCTION

FUNCTION AddOrigin$ (Text$, Signature$, Address$)
   T$ = Text$
   IF INSTR(T$, " * Origin: ") = 0 THEN
      T$ = T$ + " * Origin: " + Signature$ + " (" + Address$ + ")" + CHR$(13)
   END IF
   AddOrigin$ = T$
END FUNCTION

FUNCTION AddPath$ (Text$, Address$)
   T$ = Text$
   IF INSTR(T$, CHR$(1) + "PATH: ") = 0 THEN
      T$ = Text$ + CHR$(1) + "PATH: " + Address$ + CHR$(13)
   END IF
   AddPath$ = T$
END FUNCTION

FUNCTION AddSeenBy$ (Text$, Address$)
   T$ = Text$
   IF INSTR(T$, "SEEN-BY: ") = 0 THEN
      T$ = Text$ + "SEEN-BY: " + Address$ + CHR$(13)
   END IF
   AddSeenBy$ = T$
END FUNCTION

FUNCTION AddTearLine$ (Text$)
   T$ = Text$
   IF INSTR(Text$, CHR$(13) + "---") = 0 THEN
      T$ = Text$ + CHR$(13) + "--- Qwk2Pkt 1.0" + CHR$(13)
   END IF
   AddTearLine$ = T$
END FUNCTION

FUNCTION Convert2FidoText$ (Text$, AreaName$)
   T$ = Text$
   T$ = ConvertChars$(T$, CHR$(227), CHR$(13)) 'converts all CHR$(227) to CHR$(13)
   T$ = StripHighASCII$(T$)   'strips characters over 127
   T$ = AddEchoInfo(T$, AreaName$) 'adds Fidonet echo info to the message
   Convert2FidoText$ = T$
END FUNCTION

