'String &/or array routines
DECLARE SUB Lower (Text$)                                             'Fast LCASE$ replacement
DECLARE SUB Upper (Text$)                                             'Fast UCASE$ replacement
DECLARE FUNCTION ASCII% (Text$, BYVAL CharPos%)                       '8.6+ times faster than using X = ASC(MID$(Text$, CharPos))
DECLARE SUB MidStr (Text$, BYVAL CharPos%, BYVAL Character%)          '6.8+ times faster than using MID$(Text$, CharPos, 1) = CHR$(Character)
DECLARE FUNCTION UpChar% (BYVAL Character%)  'Capitalize CHR$(Character%)
DECLARE FUNCTION LowChar% (BYVAL Character%) 'Lowercase CHR$(Character%)
DECLARE FUNCTION UpASC% (Text$)                                       '9.25+ times faster than ASC(UCASE$(Text$))
DECLARE FUNCTION LowASC% (Text$)                                      '9.25+ times faster than ASC(LCASE$(Text$))
DECLARE FUNCTION UpASCII% (Text$, BYVAL CharPos%)                     '12.7+ times faster than ASC(UCASE$(MID$(Text$, CharPos%, 1)))
DECLARE FUNCTION LowASCII% (Text$, BYVAL CharPos%)                    '12.7+ times faster than ASC(LCASE$(MID$(Text$, CharPos%, 1)))

DECLARE SUB Mirror (Text$)                                            'Reverses the order of a string
DECLARE SUB Mirror2 (SEG Array, BYVAL NumBytes%)                      'Reverses the order of an area of memory
DECLARE SUB Mirror3 ALIAS "Mirror2" (BYVAL Segment%, BYVAL Offset%, BYVAL NumBytes%)         'Reverses the order of an area of memory

DECLARE FUNCTION AntiInstr2% (Search$, SubString$)                    'Finds the first non-SubString$ occurance in Search$--2 parameter string version
DECLARE FUNCTION AntiInstr3% (BYVAL Start%, Search$, SubString$)      'Finds the first non-SubString$ occurance in Search$--3 parameter string version
DECLARE FUNCTION AntiInstrI2% (Search$, BYVAL Character%)             'Finds the first non-CHR$(Character%) occurance in Search$--2 parameter integer version
DECLARE FUNCTION AntiInstrI3% (BYVAL Start%, Search$, BYVAL Char%)    'Finds the first non-CHR$(Char%) occurance in Search$--3 parameter integer version
DECLARE FUNCTION BackInstr2% (Search$, SubString$)                    'Searches a string from right to left--2 parameter version
DECLARE FUNCTION BackInstr3% (BYVAL Start%, Search$, SubString$)      'Searches a string from right to left--3 parameter version
DECLARE FUNCTION InArray% (SEG Array, BYVAL Char%, BYVAL NumBytes%)   'Searches an array for CHR$(Char%)

'The Neptune "Evil" library
DECLARE FUNCTION GetKey% ()                                           'Returns keycode as an integer.  Negative for extended keystrokes
DECLARE SUB InitRandom ()                                             'Seeds the random number generator
DECLARE FUNCTION GetRandom% (BYVAL MaxVal%)                           'Returns a random number between 0 and MaxVal%
DECLARE SUB SetVideoMode (BYVAL ModeNum%)                             'SCREEN statement replacement
DECLARE FUNCTION TimerCount& ()                                       'Get 18ths of a second
DECLARE FUNCTION TimerCountLow% ALIAS "TimerCount" ()                 'Get low word of BIOS tick count (18th of a second)

'Misc routines
DECLARE SUB NoPause ()                                                'Disable/reenable pause
DECLARE FUNCTION TimerTick& ()                                        'Get 1,00ths of a second
DECLARE FUNCTION TimerTick10K& ()                                     'Get 10,00ths of a second
DECLARE FUNCTION TimerTick10KLow% ALIAS "TimerTick10K" ()             'Get low word of 10,00ths of a second

'Screen 0 routines
DECLARE FUNCTION IsCCode% (Text$, BYVAL CharPos%)                     'determines if the 3 characters at CharPos are a color code
DECLARE FUNCTION SLPrint% (Text$, BYVAL X%, BYVAL Y%, BYVAL Colr%, BYVAL Start%, BYVAL RMargin%)         'print a color-coded string
DECLARE FUNCTION SLLength% (Text$)                                    'Get actual length of a color-coded string (minus color codes)
DECLARE SUB ClearEOL (BYVAL X%, BYVAL Y%)                             'Clear to End of Line in 80 column text mode

'Mode-X routines
DECLARE SUB TransBlitX (SEG Graphic, BYVAL X%, BYVAL Y%)
DECLARE SUB TransBlitX2 ALIAS "TransBlitX" (BYVAL Segment%, BYVAL Offset%, BYVAL X%, BYVAL Y%)
DECLARE SUB TCBlitX (SEG Graphic, BYVAL X%, BYVAL Y%, BYVAL Colr%)
DECLARE SUB TCBlitX2 ALIAS "TCBlitX" (BYVAL Segment%, BYVAL Offset%, BYVAL X%, BYVAL Y%, BYVAL Colr%)

DECLARE SUB LoadPalette (SEG PalData AS ANY, BYVAL StartReg%, BYVAL EndReg%)                                  'Load a palette from an array
DECLARE SUB LoadPalette2 ALIAS "LoadPalette" (BYVAL Segment%, BYVAL Offset%, BYVAL StartReg%, BYVAL EndReg%)  'Load a palette from memory
DECLARE SUB SavePalette (SEG PalData AS ANY, BYVAL StartReg%, BYVAL EndReg%)                                  'Save a palette to an array
DECLARE SUB SavePalette2 ALIAS "SavePalette" (BYVAL Segment%, BYVAL Offset%, BYVAL StartReg%, BYVAL EndReg%)  'Save a palette to memory
DECLARE SUB SetDACRegister (BYVAL Register%, BYVAL Red%, BYVAL Green%, BYVAL Blue%)
DECLARE SUB GetDACRegister (BYVAL Register%, Red%, Green%, Blue%)     'Get the values of Register% in Red%, Green% & Blue%

'Com routines
DECLARE SUB OpenCom (BYVAL ComPort%, Buffer$)                         'Open com port 1-4
DECLARE SUB OpenCom2 (BYVAL ComPort%, Buffer$)                        'Open 2nd com port 1-4
DECLARE SUB SetBPS (BYVAL Handle%, BYVAL BitRate&)                    'Set bitrate
DECLARE SUB CloseCom (BYVAL Handle%)                                  'Close com port
DECLARE SUB FlushBuffer (BYVAL Handle%)                               'Discare all characters in buffer

DECLARE FUNCTION CharsWaiting% (BYVAL Handle%)                        'Checks for pending characters in buffer
DECLARE FUNCTION GetChar% (BYVAL Handle%)                             'Get a character
DECLARE FUNCTION XMitChar% (BYVAL Handle%, BYVAL Character%)          'Transmit a character
DECLARE FUNCTION XMitString% (BYVAL Handle%, Text$)                   'Transmit a string
