
.286
IDEAL
MODEL           MEDIUM
;----------------------------------------------------------------
DATASEG
LABEL           LookUp  WORD
                Y = 0
                REPT    200
                dw      Y
                Y = Y + 320
                ENDM
RandSeed        dw      0,0
;----------------------------------------------------------------
CODESEG
ASSUME          DS:@CODE, DS:@DATA, SS:@DATA, ES:NOTHING
;----------------------------------------------------------------
;Sets a point in the 320x200x256 mode.
EVEN
PUBLIC          SetPoint
PROC            SetPoint
Xp              EQU     <[bx+8]>
Yp              EQU     <[bx+6]>
C               EQU     <[bx+4]>
P               =       3
                Mov     ax, 0A000h
                Mov     es, ax
                Mov     bx, sp
                Mov     ax, C
                Mov     di, Xp
                Mov     bx, Yp
                Shl     bx, 1
                Add     di, [bx+LookUp]
                Stosb
                Retf    P*2
ENDP            SetPoint
;----------------------------------------------------------------
;Grabs a point's color in the 320x200x256 mode.
EVEN
PUBLIC          GetPoint
PROC            GetPoint
Xp              EQU     <[bx+6]>
Yp              EQU     <[bx+4]>
P               =       2
                Mov     ax, 0A000h
                Mov     es, ax
                Mov     bx, sp
                Mov     si, Xp
                Mov     bx, Yp
                Shl     bx, 1
                Add     si, [bx+LookUp]
                Xor     ax, ax
                Lods    [byte es:si]
                Retf    P*2
ENDP            GetPoint
;----------------------------------------------------------------
;Seeds the psuedo-random number generator.
PUBLIC          SeedRand
PROC            SeedRand
NewSeedH        EQU     <[bx+6]>
NewSeedL        EQU     <[bx+4]>
P               =       2
                Mov     bx, sp
                Mov     ax, NewSeedL
                Mov     [RandSeed], ax
                Mov     ax, NewSeedH
                Mov     [RandSeed+2], ax
                Retf    P*2
ENDP            SeedRand
;----------------------------------------------------------------
;Returns psuedo-random number between 0 and MaxVal-1.
EVEN
PUBLIC          GetRand
PROC            GetRand
MaxVal          EQU     <[word bx+4]>
P               =       1
                Mov     ax, [RandSeed]
                Mov     bx, [RandSeed+2]
                Mov     cx, ax
                Mov     dx, 08405h
                Mul     dx
                Shl     cx, 3
                Add     ch, cl
                Add     dx, cx
                Add     dx, bx
                Shl     bx, 1
                Shl     bx, 1
                Add     dx, bx
                Add     dh, bl
                Shl     bx, 5
                Add     dh, bl
                Add     ax, 1
                Adc     dx, 0
                Mov     [RandSeed], ax
                Mov     [RandSeed+2], dx
                Mov     bx, sp
                Mov     cx, dx
                Mul     MaxVal
                Mov     ax, cx
                Mov     cx, dx
                Mul     MaxVal
                Add     ax, cx
                Adc     dx, 0
                Mov     ax, dx
                Retf    P*2
ENDP            GetRand
;----------------------------------------------------------------
END
