
'PLASMA.BAS
'Input graininess on command line. Valid values are 0-40.
'Try running with a graininess of 1, and zooming in on areas with
'very little overall elevation (ie. areas that are mostly the same
'color). Some very interesting "non-cloudly" patterns will show
'themselves if you look at the right areas. If you do get some wierd
'looking patterns, make sure you try color cycling with a random
'palette.
'
'Keys recognized:
'"C"        = Toggles color cycling.
'"R"        = Sets the default palette.
'"1" to "9" = Introduces random colors into the palette while color
'             cycling.
'Array keys = Moves zoom box.
'Enter      = Zooms area inside zoom box.
'Escape     = Quits.
'
DEFINT A-Z

DECLARE SUB SubDivide (CX1%, CY1%, CX2%, CY2%, CC1%, CC2%, CC3%, CC4%)
DECLARE SUB SetPoint (BYVAL X, BYVAL Y, BYVAL C)
DECLARE FUNCTION GetPoint (BYVAL X, BYVAL Y)
DECLARE SUB SeedRand (BYVAL NewSeed&)
DECLARE FUNCTION GetRand% (BYVAL MaxRand%)

TYPE StackType
    X1 AS INTEGER
    Y1 AS INTEGER
    X2 AS INTEGER
    Y2 AS INTEGER
    C1 AS INTEGER
    C2 AS INTEGER
    C3 AS INTEGER
    C4 AS INTEGER
END TYPE

DIM SHARED AStack(511) AS StackType
DIM SHARED Clamp(-4096 TO 4096)
DIM SHARED F&
DIM SHARED P(0 TO 40, 0 TO 40)
DIM SHARED D(0 TO 40, 0 TO 40)
DIM r(255), g(255), b(255)

A$ = COMMAND$
IF LEN(A$) THEN
    F& = VAL(A$)
    IF F& < 0 THEN
        F& = 0
    ELSEIF F& > 40 THEN
        F& = 40
    END IF
ELSE
    F& = 8
END IF

FOR A = -4096 TO 4096
    IF A < 1 THEN
        Clamp(A) = 1
    ELSEIF A > 255 THEN
        Clamp(A) = 255
    ELSE
        Clamp(A) = A
    END IF
NEXT

SCREEN 13

'Set default palette.
GOSUB PalSet

'Seed the psuedo-random number generator with the current time.
DEF SEG = &H40
SeedRand PEEK(&H6C) + PEEK(&H6D) * 256& + PEEK(&H6E) * 65536

'Draw plasma.
C1 = GetRand(256) + 1
C2 = GetRand(256) + 1
C3 = GetRand(256) + 1
C4 = GetRand(256) + 1
SetPoint 0, 0, C1
SetPoint 319, 0, C2
SetPoint 319, 199, C3
SetPoint 0, 199, C4

'Plot the starting plasma.
CALL SubDivide(0, 0, 319, 199, C1, C2, C3, C4)

C = 1

DO
    Xs = (320 - 40) \ 2
    Ys = (200 - 40) \ 2

    DO
        FOR A = 0 TO 41
            SetPoint Xs + A, Ys, GetPoint(Xs + A, Ys) XOR &HAA
            SetPoint Xs + A, Ys + 41, GetPoint(Xs + A, Ys + 41) XOR &HAA
            SetPoint Xs, Ys + A, GetPoint(Xs, Ys + A) XOR &HAA
            SetPoint Xs + 41, Ys + A, GetPoint(Xs + 41, Ys + A) XOR &HAA
        NEXT

        DO
            IF CycleOn THEN
                IF RandC > 0 THEN
                    IF GetRand(10) <= RandFreq THEN
                        r(RandC) = GetRand(64)
                        g(RandC) = GetRand(64)
                        b(RandC) = GetRand(64)
                    ELSE
                        r(RandC) = 0
                        g(RandC) = 0
                        b(RandC) = 0
                    END IF
                    RandC = RandC + 1
                    IF RandC = 256 THEN
                        RandC = 0
                    END IF
                END IF

                WAIT &H3DA, 8
                OUT &H3C8, 1
                D = C
                FOR A = 1 TO 255
                    OUT &H3C9, r(D)
                    OUT &H3C9, g(D)
                    b = b(D)
                    WAIT &H3DA, 1
                    OUT &H3C9, b
                    WAIT &H3DA, 1, 1
                    D = D + 1
                    IF D = 256 THEN D = 1
                NEXT
                C = C + 1
                IF C = 256 THEN C = 1
                WAIT &H3DA, 8, 8
            END IF

            A$ = INKEY$
        LOOP UNTIL LEN(A$)

        FOR A = 0 TO 41
            SetPoint Xs + A, Ys, GetPoint(Xs + A, Ys) XOR &HAA
            SetPoint Xs + A, Ys + 41, GetPoint(Xs + A, Ys + 41) XOR &HAA
            SetPoint Xs, Ys + A, GetPoint(Xs, Ys + A) XOR &HAA
            SetPoint Xs + 41, Ys + A, GetPoint(Xs + 41, Ys + A) XOR &HAA
        NEXT

        SELECT CASE A$
        CASE CHR$(0) + CHR$(72) 'up
            Ys = Ys - 5
            IF Ys < 0 THEN Ys = 0
               CASE CHR$(0) + CHR$(80) 'down
            Ys = Ys + 5
            IF Ys > 200 - 42 THEN Ys = 200 - 42
        CASE CHR$(0) + CHR$(77) 'right
            Xs = Xs + 5
            IF Xs > 320 - 42 THEN Xs = 320 - 42
        CASE CHR$(0) + CHR$(75)'left
            Xs = Xs - 5
            IF Xs < 0 THEN Xs = 0
        CASE CHR$(13), "0"
            EXIT DO
        CASE "C", "c"
            CycleOn = NOT CycleOn
        CASE "R", "r"
            GOSUB PalSet
            C = 1
        CASE "1" TO "9"
            RandC = 1
            RandFreq = ASC(A$) - 49
        CASE CHR$(27)
            END
        END SELECT
    LOOP

    L = 256
    H = 0
    FOR Y = Ys TO Ys + 40
        FOR X = Xs TO Xs + 40
            P = GetPoint(X, Y) - 1
            IF P < L THEN L = P
            IF P > H THEN H = P
            P(X - Xs, Y - Ys) = P
        NEXT
    NEXT

    'Maximize the scale of the new plasma to take advantage of
    'all colors- this will usually cause the zoomed plasma's colors to
    'appear different from its original colors, but must be done because
    'there are only 256 colors available.
    IF (H - L) = 0 THEN 'avoid overflow error
        Scaler& = 256
    ELSE
        Scaler& = (255 * 256&) \ (H - L)
    END IF

    FOR Y = 0 TO 40
        FOR X = 0 TO 40
            P = 1 + ((P(X, Y) - L) * Scaler&) \ 256
            IF P > 255 THEN P = 255
            P(X, Y) = P
        NEXT
    NEXT

    CLS

    FOR Y = 0 TO 40
        Ys = Y * 5: IF Ys > 199 THEN Ys = 199
        FOR X = 0 TO 40
            Xs = X * 8: IF Xs > 319 THEN Xs = 319
            SetPoint Xs, Ys, P(X, Y)
        NEXT
    NEXT

    ERASE D

    'Fill in the black areas.
    FOR Y = 0 TO 39
        Ys = Y * 5
        Ye = Ys + 5
        IF Ye > 199 THEN Ye = 199
        FOR X = 0 TO 39
            Xs = X * 8
            Xe = Xs + 8
            IF Xe > 319 THEN Xe = 319
            CALL SubDivide(Xs, Ys, Xe, Ye, P(X, Y), P(X + 1, Y), P(X + 1, Y + 1), P(X, Y + 1))
        NEXT
    NEXT
LOOP UNTIL A$ = CHR$(27)
END

PalSet:
  'Alter this section here for another palette.
  FOR A = 0 TO 63
    s = 0: r = 63: g = A: b = 0: GOSUB Set
    s = 64: r = 63 - A: g = 63: b = 0: GOSUB Set
    s = 128: r = 0: g = 63 - A: b = A: GOSUB Set
    s = 192: r = A: g = 0: b = 63: GOSUB Set
  NEXT
RETURN

Set:
  IF A + s = 0 THEN RETURN  'to keep the background black
  r(A + s) = r
  g(A + s) = g
  b(A + s) = b
  OUT &H3C8, A + s
  OUT &H3C9, r
  OUT &H3C9, g
  OUT &H3C9, b
RETURN

'This subroutine subdivides the screen into small areas
'and fills them in with psuedo-random colors. Areas close the each
'other are very similar, but as the distance increases between two
'areas they grow very different.
SUB SubDivide (CX1, CY1, CX2, CY2, CC1, CC2, CC3, CC4)

    SP = 0
    AStack(SP).X1 = CX1: AStack(SP).Y1 = CY1
    AStack(SP).X2 = CX2: AStack(SP).Y2 = CY2
    AStack(SP).C1 = CC1: AStack(SP).C2 = CC2
    AStack(SP).C3 = CC3: AStack(SP).C4 = CC4
    SP = SP + 1

    DO WHILE SP
        SP = SP - 1
        X1 = AStack(SP).X1: Y1 = AStack(SP).Y1
        X2 = AStack(SP).X2: Y2 = AStack(SP).Y2
        C1 = AStack(SP).C1: C2 = AStack(SP).C2
        C3 = AStack(SP).C3: C4 = AStack(SP).C4
Jag:
        'Find center of area.
        X = (X1 + X2) \ 2
        Y = (Y1 + Y2) \ 2

        CA = GetPoint(X, Y1)
        IF CA = 0 THEN
            CA = Clamp((C1 + C2) \ 2 + ((GetRand(128) - 64) * (X2 - X1) * F&) \ 256)
            SetPoint X, Y1, CA
        END IF

        CB = GetPoint(X2, Y)
        IF CB = 0 THEN
            CB = Clamp((C2 + C3) \ 2 + ((GetRand(128) - 64) * (Y2 - Y1) * F&) \ 256)
            SetPoint X2, Y, CB
        END IF

        CC = GetPoint(X, Y2)
        IF CC = 0 THEN
            CC = Clamp((C4 + C3) \ 2 + ((GetRand(128) - 64) * (X2 - X1) * F&) \ 256)
            SetPoint X, Y2, CC
        END IF

        CD = GetPoint(X1, Y)
        IF CD = 0 THEN
            CD = Clamp((C1 + C4) \ 2 + ((GetRand(128) - 64) * (Y2 - Y1) * F&) \ 256)
            SetPoint X1, Y, CD
        END IF

        CM = GetPoint(X, Y)
        'Set center point to the average of all the pixels
' surrounding it.
        IF CM = 0 THEN
            CM = (C1 + C2 + C3 + C4 + CA + CB + CC + CD) \ 8
            SetPoint X, Y, CM
        END IF

        IF X2 - X1 > 2 THEN
            'Recursively subdivide the area into 4 smaller areas.

            'CALL SubDivide(X, Y, X2, Y2, CM, CB, C3, CC)
            AStack(SP).X1 = X: AStack(SP).Y1 = Y
            AStack(SP).X2 = X2: AStack(SP).Y2 = Y2
            AStack(SP).C1 = CM: AStack(SP).C2 = CB
            AStack(SP).C3 = C3: AStack(SP).C4 = CC
            SP = SP + 1

            'CALL SubDivide(X1, Y1, X, Y, C1, CA, CM, CD)
            AStack(SP).X1 = X1: AStack(SP).Y1 = Y1
            AStack(SP).X2 = X: AStack(SP).Y2 = Y
            AStack(SP).C1 = C1: AStack(SP).C2 = CA
            AStack(SP).C3 = CM: AStack(SP).C4 = CD
            SP = SP + 1

            'CALL SubDivide(X, Y1, X2, Y, CA, C2, CB, CM)
            AStack(SP).X1 = X: AStack(SP).Y1 = Y1
            AStack(SP).X2 = X2: AStack(SP).Y2 = Y
            AStack(SP).C1 = CA: AStack(SP).C2 = C2
            AStack(SP).C3 = CB: AStack(SP).C4 = CM
            SP = SP + 1

            'CALL SubDivide(X1, Y, X, Y2, CD, CM, CC, C4)
            Y1 = Y
            X2 = X
            C1 = CD
            C2 = CM
            C3 = CC
            GOTO Jag

        END IF

    LOOP

END SUB
