'>>> Page 1 of POLYFILL.BAS begins here. TYPE:BAS
'POLYFILL.BAS by Rich Geldreich 1993
'This program contains a simple convex polygon filling subroutine.
'This subroutine is much faster than using QB's "PAINT" command
'to fill in polygons.
DEFINT A-Z

DECLARE SUB PolyFill (C%, MaxPoint%, x%(), y%())
DECLARE SUB PlotLine (xs%, ys%, xe%, ye%)

CONST True = -1, False = 0
'Modify these constants for different video modes.
CONST MinX = 0, MaxX = 639
CONST MinY = 0, MaxY = 479

TYPE EdgeType
    LeftEdge    AS INTEGER
    RightEdge   AS INTEGER
END TYPE

DIM SHARED PolyEdge(MinY TO MaxY) AS EdgeType

'Here's an example usage...
SCREEN 7

DIM x(0 TO 3), y(0 TO 3)
x(0) = 50: y(0) = 50
x(1) = 270: y(1) = 50
x(2) = 270: y(2) = 150
x(3) = 50: y(3) = 150
'Use arrow keys to move vertex. Select which vertex to move by using
'keys 1-4. Hit escape to exit.
DO
    CLS
    PolyFill 9, 3, x(), y()
    DO: A$ = INKEY$: LOOP UNTIL A$ <> ""
    A = ASC(RIGHT$(A$, 1)) * ((LEN(A$) = 2) OR 1)
    SELECT CASE A
    CASE -72: y(q) = y(q) - 5
    CASE -80: y(q) = y(q) + 5
    CASE -75: x(q) = x(q) - 5
    CASE -77: x(q) = x(q) + 5
    CASE 49, 50, 51, 52: q = A - 49
    CASE 27: END
    END SELECT
LOOP

'Enters a line into the edge list.
SUB PlotLine (xs, ys, xe, ye)
    IF ys > ye THEN SWAP xs, xe: SWAP ys, ye
    IF (ys > MaxY) OR (ye < MinY) THEN EXIT SUB

    IF ys < MinY THEN
        xs = xs - ((xe - xs) * CLNG(ys - MinY)) \ (ye - ys)
        ys = MinY
    END IF

    IF ye > MaxY THEN
        xe = xe - ((xe - xs) * CLNG(ye - MaxY)) \ (ye - ys)
        ye = MaxY
    END IF

    xd = ABS(xe - xs) + 1: yd = ABS(ye - ys) + 1

    IF xd = 1 THEN
        FOR A = ys TO ye
            IF xs < PolyEdge(A).LeftEdge THEN PolyEdge(A).LeftEdge =_
 xs
            IF xs > PolyEdge(A).RightEdge THEN PolyEdge(A).RightEdge_
 = xs
        NEXT
    ELSEIF yd = 1 THEN
        IF xs < PolyEdge(ys).LeftEdge THEN PolyEdge(ys).LeftEdge = xs
        IF xe > PolyEdge(ys).RightEdge THEN PolyEdge(ys).RightEdge =_
 xe
    ELSEIF xd > yd THEN
        s& = (xd * 256&) \ yd
        eh = (s& \ 256) - 1
        el = s& AND 255
        e = 128

        IF xs > xe THEN SWAP xs, xe: SWAP ys, ye
        x = xs
        FOR A = ys TO ye STEP SGN(ye - ys)
            IF x < PolyEdge(A).LeftEdge THEN
                PolyEdge(A).LeftEdge = x
            END IF
            e = e + el
            x = x + eh
            IF e > 255 THEN x = x + 1: e = e - 256
            IF x > PolyEdge(A).RightEdge THEN
                PolyEdge(A).RightEdge = x
            END IF
            x = x + 1
        NEXT
    ELSE
        s& = (yd * 256&) \ xd
        eh = (s& \ 256) - 1
        el = s& AND 255
        e = 128
        y = ys
        FOR A = xs TO xe STEP SGN(xe - xs)
            e = e + el
            t = eh
            IF e > 255 THEN t = t + 1: e = e - 256
            FOR y = y TO y + t
                IF A < PolyEdge(y).LeftEdge THEN
                    PolyEdge(y).LeftEdge = A
                END IF
                IF A > PolyEdge(y).RightEdge THEN
                    PolyEdge(y).RightEdge = A
                END IF
            NEXT
        NEXT
    END IF
END SUB

'Fills a convex polygon. Parameters are:
'C         = Filling color.
'MaxPoint  = Number of vertexes, less one.
'x(),y()   = Vertex list.
SUB PolyFill (C, MaxPoint, x(), y())
    IF MaxPoint = 0 THEN EXIT SUB

    PolyMinY = 32767: PolyMaxY = -32768
    FOR A = 0 TO MaxPoint
        y = y(A)
        IF y < PolyMinY THEN PolyMinY = y
        IF y > PolyMaxY THEN PolyMaxY = y
    NEXT
    IF (PolyMinY > MaxY) OR (PolyMaxY < MinY) THEN EXIT SUB
    IF PolyMinY < MinY THEN PolyMinY = MinY
    IF PolyMaxY > MaxY THEN PolyMaxY = MaxY

    PolyMinX = 32767: PolyMaxX = -32768
    FOR A = 0 TO MaxPoint
        x = x(A)
        IF x < PolyMinX THEN PolyMinX = x
        IF x > PolyMaxX THEN PolyMaxX = x
    NEXT
    IF (PolyMinX > MaxX) OR (PolyMaxX < MinX) THEN EXIT SUB

    PolyEdge(MinY).LeftEdge = 32767
    PolyEdge(MinY).RightEdge = -32768
    FOR y = PolyMinY TO PolyMaxY
        PolyEdge(y) = PolyEdge(MinY)
    NEXT
    FOR A = 0 TO MaxPoint - 1
        PlotLine (x(A)), (y(A)), (x(A + 1)), (y(A + 1))
    NEXT
    PlotLine (x(MaxPoint)), (y(MaxPoint)), (x(0)), (y(0))

    FOR y = PolyMinY TO PolyMaxY
        xs = PolyEdge(y).LeftEdge
        xe = PolyEdge(y).RightEdge
        IF (xs <= MaxX) AND (xe >= MinX) THEN
            IF xs < MinX THEN xs = MinX
            IF xe > MaxX THEN xe = MaxX
            LINE (xs, y)-(xe, y), C
        END IF
    NEXT
END SUB

