'************************************************************
'**   PULLDOWN.BAS   Pulldown menu system by Mark H Butler **
'**                  December, 1992 - use it and enjoy!    **
'************************************************************
'**                  Modified by Robert Church             **
'**                  January, 1993 - use it and enjoy!     **
'************************************************************

DEFINT A-Z
CONST UpArrow = 72, DownArrow = 80, Escape = 27, Enter = 13, F1 = 59
CONST Home = 71, EndKey = 79, LeftArrow = 75, RightArrow = 77
CONST CtrlHome = 119, CtrlEnd = 117, PageDown = 81, PageUp = 73
DECLARE FUNCTION Center% (text$)
DECLARE SUB BarMenu (Row, Col, spacing, BarPrompt$(), return$, startpos)
DECLARE SUB Burp ()
DECLARE SUB ChangeRowColor (Row%, Col1%, Col2%, Attrib%)
DECLARE SUB CheckMoves ()
DECLARE SUB ClearKbd ()
DECLARE SUB Desktop ()
DECLARE SUB DialogBox (DialStr$(), Row%, Col%, WaitForKey%)
DECLARE SUB DrawBox (Uprow%, LtCol%, Lorow%, RtCol%)
DECLARE SUB Help (HelpData$())
DECLARE SUB MenuBox (Row, Col, Item$(), ItemNum, MaxItems, movekey)
'This is the QB internal memory mover.  You can't use this in the
'environment.
'DECLARE SUB MemCopy ALIAS "B$ASSN" (BYVAL FSeg%, BYVAL FOfs%, BYVAL NBytes1%, BYVAL TSeg%, BYVAL TOfs%, BYVAL NBytes2%)
'This declare is for the one I use.
DECLARE SUB MemCopy (FSeg%, FOfs%, TSeg%, TOfs%, NBytes%)
DECLARE SUB Pause (ticks)
DECLARE SUB PokeBar ()
DECLARE SUB RestScrn (Scr())
DECLARE SUB ScrollBox (Row%, Col%, Item$(), ItemNum%, MaxItems%, OnScreen%, movekey%)
DECLARE SUB SaveScrn (Scr())
DECLARE SUB Shade (Uprow, LtCol, Lorow, RtCol)
DECLARE SUB TextBox (Txt$(), Row%, Col%, OnScreen%, Wid%, StartLine%, ExitKey$)
DECLARE FUNCTION YesNoBox% (Txt$(), Row%, Col%, Default%)

DIM SHARED Scr(4000)
DIM BarPrompt$(1 TO 6)
DIM Menu1$(1 TO 9), Menu2$(1 TO 7), Menu3$(1 TO 12), Menu4$(1 TO 3)
DIM Menu5$(1 TO 6), Menu6$(1 TO 3)

    Desktop
    GOSUB FillMenus

    '*** initialize flags
    movekey = 0
    startpos = 1
    trigger = 0

    DO
        return$ = ""
        CALL BarMenu(1, 1, 4, BarPrompt$(), return$, startpos)
        HotCharPos = INSTR(HotChar$, return$)
        IF return$ = "aborted" THEN HotCharPos = 0
        SaveScrn Scr()
        SELECT CASE HotCharPos
            CASE 0
                RestScrn Scr()
                REDIM Txt$(1 TO 1)
                Txt$(1) = "     Exit to DOS? "
                Default = -1
                IF YesNoBox(Txt$(), 0, 0, Default) THEN
                  COLOR 7, 0
                  CLS
                  PRINT "User aborted..."
                  END
                END IF
            CASE 1
                CALL MenuBox(2, 2, Menu1$(), ItemNum, 9, movekey)
            CASE 2
                CALL MenuBox(2, 10, Menu2$(), ItemNum, 7, movekey)
            CASE 3
                CALL MenuBox(2, 18, Menu3$(), ItemNum, 12, movekey)
            CASE 4
                CALL MenuBox(2, 26, Menu4$(), ItemNum, 3, movekey)
            CASE 5
                CALL MenuBox(2, 37, Menu5$(), ItemNum, 6, movekey)
            CASE 6
                CALL MenuBox(2, 47, Menu6$(), ItemNum, 3, movekey)
        END SELECT
        CheckMoves
        IF ItemNum > 0 THEN
            IF HotCharPos = 6 THEN
               SELECT CASE ItemNum
                  CASE 1   'try TextBox
                     REDIM Txt$(1 TO 20)
                     Txt$(1) = " Welcome to the TextBox demo!  Notice how the screen"
                     Txt$(2) = " scrolls both vertically and horizontally.  You can use the "
                     Txt$(3) = " arrow keys to scroll.  You can also jump to the begging"
                     Txt$(4) = " or end of the line with <HOME> and <END> repectively."
                     Txt$(5) = " Want to jump to the top or bottom of the text?  Try"
                     Txt$(6) = " <Ctrl-HOME> and <Ctrl-END>.  In addition, <PgUP> and "
                     Txt$(7) = " <PgDOWN> work as per expected."
                     Txt$(9) = " Now let's talk about this routine from the programmer's"
                     Txt$(10) = "perspective.  The declaration looks like this:  "
                     Txt$(12) = "DECLARE SUB TextBox (Txt$(), Row%, col%, OnScreen%, Wid, StartLine%, ExitKey$)"
                     Txt$(13) = "  Txt$() is a string array containing the text to be displayed"
                     Txt$(14) = "  Row%, Col% is the position at which the box is to be displayed.  If these are 0 then the box will be auto centered."
                     Txt$(15) = "  OnScreen% is the number of lines of text that will be on-screen at one time.  Also the height of the box."
                     Txt$(16) = "  Wid% is the width of the box on the screen.  If there are lines in the text that are longer than the box will fit, it will be able to scroll."
                     Txt$(17) = "  StartLine% is the line of text that will be at the top of the box when the routine starts."
                     Txt$(18) = "  ExitKey$ is the key used to end the routine.  TextBox ends when any key other than one of the editing keys is hit.  This allows the routine to be more versatile."
                     Txt$(20) = "...and there you have it!  I hope you have enjoyed this journey into the depths of TextBox."
                     DO
                        TextBox Txt$(), 0, 0, 6, 55, l, K$
                     LOOP UNTIL K$ = CHR$(Escape)
                  CASE 2   'try ScrollBox
                     DIM Items$(1 TO 25)
                     FOR a = 1 TO 25
                        Items$(a) = "Item" + STR$(a)
                     NEXT a
                     ScrollBox 5, 10, Items$(), ItemNum, 25, 7, movekey
                     LOCATE 25, 25
                     COLOR 14, 4
                     PRINT " You chose menu Item #"; ItemNum;
                  CASE 3
                     REDIM Txt$(1 TO 5)
                     Txt$(1) = "     Welcome to DialogBox! "
                     Txt$(2) = " This routine basically displays text"
                     Txt$(3) = " in a box on the screen and waits for"
                     Txt$(4) = " a  keypress.   It can  also  display"
                     Txt$(5) = " text and leave it there."
                     DialogBox Txt$(), 0, 0, -1
               END SELECT
            ELSE
               LOCATE 25, 25
               COLOR 14, 4
               PRINT " You chose menu #"; HotCharPos; ", Item #"; ItemNum;
            END IF
            Pause 5 * 18
            trigger = 0
            startpos = 1
        END IF
        ClearKbd
        RestScrn Scr()
    LOOP

'======================================================================
'               M E N U   D A T A
'======================================================================

FillMenus:

    BarPrompt$(1) = "Rend"
    BarPrompt$(2) = "Tear"
    BarPrompt$(3) = "Kill"
    BarPrompt$(4) = "Destroy"
    BarPrompt$(5) = "Mayhem"
    BarPrompt$(6) = "Examples"

    HotChar$ = "RTKDME" '<---*** first letter of each barmenu item

    FOR i = 1 TO 9
        READ Menu1$(i)
    NEXT
    DATA First Menu1 Option, Second Menu1 Option,Third Menu1 Option
    DATA Fourth Menu1 Option,Fifth Menu1 Option,Sixth Menu1 Option
    DATA Seventh Menu1 Option,Eighth Menu1 Option,Ninth Menu1 Option

    FOR i = 1 TO 7
        READ Menu2$(i)
    NEXT
    DATA First Menu2 Option, Second Menu2 Option,Third Menu2 Option
    DATA Fourth Menu2 Option,Fifth Menu2 Option,Sixth Menu2 Option
    DATA Seventh Menu2 Option

    FOR i = 1 TO 12
        READ Menu3$(i)
    NEXT
    DATA First Menu3 Option, Second Menu3 Option,Third Menu3 Option
    DATA Fourth Menu3 Option,Fifth Menu3 Option,Sixth Menu3 Option
    DATA Seventh Menu3 Option,Eighth Menu3 Option,Ninth Menu3 Option
    DATA Tenth Menu3 Option,Eleventh Menu3 Option,Twelfth Menu3 Option

    FOR i = 1 TO 3
        READ Menu4$(i)
    NEXT
    DATA First Menu4 Option, Second Menu4 Option,Third Menu4 Option

    FOR i = 1 TO 6
        READ Menu5$(i)
    NEXT
    DATA First Menu5 Option, Second Menu5 Option,Third Menu5 Option
    DATA Fourth Menu5 Option,Fifth Menu5 Option,Sixth Menu5 Option

    FOR i = 1 TO 3
        READ Menu6$(i)
    NEXT
    DATA Try out TextBox routine, Try ScrollBox routine
    DATA Try DialogBox routine

    RETURN

SUB BarMenu (Row, Col, spacing, prompt$(), return$, startpos)
SHARED trigger

    first = LBOUND(prompt$)
    last = UBOUND(prompt$)
    REDIM position(first TO last)
    DIM HelpStr$(1 TO 3)
    HelpStr$(1) = "Use the arrow keys to move the cursor"
    HelpStr$(2) = "between selections and press <ENTER> or"
    HelpStr$(3) = "the down arrow to select."

'*** Create the menu bar and remember the 'hotchars' (first letter
'*** of each drop menu heading.

    IF NOT trigger THEN
        COLOR 0, 7
        LOCATE Row, Col, 0
        PRINT SPACE$(80);
    END IF
    LOCATE Row, Col
    PRINT "   ";


    FOR i = first TO last
        position(i) = POS(1)
        IF NOT trigger THEN
            COLOR 15, 7
        ELSE
            COLOR 0, 7
        END IF
        PRINT LEFT$(prompt$(i), 1);
        COLOR 0, 7
        PRINT RIGHT$(prompt$(i), LEN(prompt$(i)) - 1); SPC(spacing);
        HotChar$ = HotChar$ + CHR$(ASC(prompt$(i)))
    NEXT i

'*** Move around on the bar and get user intput.
'*** Valid keys: Right-arrow, Left-arrow, Home & End keys to move.
'*** Enter, First letter of menu option and Down-arrow to choose.
'*** Escape key to abort.

    current = startpos
    moveto = current

    return$ = ""
    DO
        LOCATE Row, position(current) - 1
        COLOR 7, 0
        PRINT " "; prompt$(current); " "
        IF return$ <> "" THEN
            EXIT SUB
        END IF
        IF trigger THEN
            ch$ = CHR$(0) + "P"
        ELSE
            ch$ = ""
        END IF
        DO WHILE ch$ = ""
            ch$ = UCASE$(INKEY$)
        LOOP
        IF ASC(ch$) = 0 THEN
            SpecialKey = ASC(RIGHT$(ch$, 1))
            SELECT CASE SpecialKey
                CASE 59
                    Help HelpStr$()
                CASE DownArrow
                    PokeBar
                    trigger = -1
                    return$ = CHR$(ASC(prompt$(current)))
                CASE Home
                    moveto = first
                CASE EndKey
                    moveto = last
                CASE LeftArrow
                    moveto = moveto - 1
                CASE RightArrow
                    moveto = moveto + 1
                CASE ELSE
                Burp
            END SELECT
            IF moveto < first THEN moveto = last
            IF moveto > last THEN moveto = first
        ELSEIF ch$ = CHR$(13) THEN
            trigger = -1
            return$ = CHR$(ASC(prompt$(current)))
        ELSEIF ch$ = CHR$(27) THEN
            return$ = "aborted"
        ELSEIF INSTR(HotChar$, ch$) > 0 THEN
            PokeBar
            return$ = ch$
            moveto = INSTR(HotChar$, ch$)
            trigger = -1
        ELSE
            Burp
        END IF
        IF moveto <> current AND NOT trigger THEN
            LOCATE Row, position(current) - 1
            IF NOT trigger THEN
                COLOR 15, 7
            ELSE
                COLOR 0, 7
            END IF
            PRINT " "; LEFT$(prompt$(current), 1);
            COLOR 0, 7
            PRINT RIGHT$(prompt$(current), LEN(prompt$(current)) - 1); SPC(spacing);
        END IF
        current = moveto
        IF trigger THEN PokeBar
        ch$ = ""
    LOOP
    trigger = -1
END SUB

SUB Burp
    SOUND 70, .5
    SOUND 37, .5
END SUB

FUNCTION Center% (text$)
    Center% = ((80 - LEN(text$)) \ 2)
END FUNCTION

SUB ChangeRowColor (Row%, Col1%, Col2%, Attrib%)

Ro% = Row% - 1
Co1% = Col1% - 1
Co2% = Col2% - 1

DEF SEG = 0
IF (PEEK(&H410) AND &H30) = &H30 THEN VidSeg = &HB000 ELSE VidSeg = &HB800

DEF SEG = VidSeg

FOR C = Co1% TO Co2%
   Address = (C + 80 * Ro%) * 2
   POKE Address + 1, Attrib%
NEXT C

DEF SEG

END SUB

SUB CheckMoves
SHARED trigger, startpos, HotCharPos, movekey, return$, ItemNum
    IF movekey <> 0 THEN
        trigger = -1
        startpos = HotCharPos + movekey
        IF startpos > 6 THEN startpos = 1
        IF startpos < 1 THEN startpos = 6
        movekey = 0
        return$ = ""
        ItemNum = 0
    END IF
END SUB

SUB ClearKbd
    DO UNTIL INKEY$ = "": LOOP
END SUB

SUB Desktop

    COLOR 7, 1
    CLS
    DEF SEG = &H40
    equip = PEEK(&H10)
    IF (equip AND 48) = 48 THEN
        DEF SEG = &HB000
    ELSE
        DEF SEG = &HB800
    END IF

    FOR x = 0 TO 4000 STEP 2
        POKE x, 32
    NEXT
    DEF SEG
    COLOR 0, 7
    LOCATE 25, 1
    PRINT " This is the last line on the screen.  >PUT MESSAGE HERE<           ";
    PRINT "  F1 Help  ";
    
END SUB

SUB DialogBox (DialStr$(), Row%, Col%, WaitForKey%)
   DIM DialScr(1 TO 2000)
   IF WaitForKey% THEN CALL SaveScrn(DialScr())
   Upper% = UBOUND(DialStr$)
   Lower% = LBOUND(DialStr$)
   COLOR 0, 7
   Height = Upper% - Lower% + 2
   FOR i = Lower% TO Upper%
      l = LEN(DialStr$(i))
      IF l > Wid THEN Wid = l
   NEXT i
   Wid = Wid + 3
   DrawBox Row%, Col%, Height, Wid
   Shade Row%, Col%, Row + Height, Col% + Wid + 1
   IF Row% = 0 THEN Row% = ((25 - Height%) \ 2) + 1
   IF Col% = 0 THEN Col% = Center%(DialStr$(StrNum))
   FOR i = Row% + 1 TO (Row% + 1) + (Upper% - Lower%)
      StrNum = StrNum + 1
      LOCATE i, Col% + 1
      PRINT DialStr$(StrNum)
   NEXT i
   IF WaiForKey% THEN
      DO UNTIL LEN(INKEY$): LOOP
      ClearKbd
      CALL RestScrn(DialScr())
   END IF
END SUB

SUB DrawBox (Uprow%, LtCol%, Height%, Wide%)
    'modified so that the box can be centered horizontally
    'and not vertically, or visa versa.
    IF Uprow% = 0 THEN Uprow% = ((25 - Height%) \ 2) + 1
    IF LtCol% = 0 THEN LtCol% = ((80 - (Wide% + 3)) \ 2) + 1
    Lowrow% = Uprow% + Height%
    LOCATE Uprow%, LtCol%
    PRINT CHR$(218); STRING$(Wide%, CHR$(196)); CHR$(191);
    FOR i% = Uprow% + 1 TO Lowrow% - 1
        LOCATE i%, LtCol%
        PRINT CHR$(179); '*** SPACE$(Wide%); <- for filled box
        PRINT SPACE$(Wide%);
        PRINT CHR$(179);
    NEXT
    LOCATE Lowrow%, LtCol%
    PRINT CHR$(192); STRING$(Wide%, CHR$(196)); CHR$(217);
END SUB

SUB Help (HelpData$())
   COLOR 0, 7
   DIM HelpScr(1 TO 2000)
   SaveScrn HelpScr()
   DialogBox HelpData$(), 0, 0, 0
   DO: LOOP UNTIL LEN(INKEY$)
   RestScrn HelpScr()
END SUB

SUB MenuBox (Row, Col, Item$(), ItemNum, MaxItems, movekey)
SHARED trigger, startpos
    DIM HelpStr$(1 TO 4)
    HelpStr$(1) = "Use the up and down arrows to move"
    HelpStr$(2) = "between selections and use the <ENTER>"
    HelpStr$(3) = "to select.  Use the right and left"
    HelpStr$(4) = "arrows to switch menus and <ESC> to cancel."

    Row = Row + 1
    Col = Col + 1
    ItemNum = 1
    ItemLength = 1
    FOR i = 1 TO MaxItems
    IF LEFT$(Item$(i), 1) <> " " THEN
        Item$(i) = " " + Item$(i) + " "
    END IF
    NEXT i
    FOR i = 1 TO MaxItems
        IF LEN(Item$(i)) > ItemLength THEN
            ItemLength = LEN(Item$(i))
        ELSEIF LEN(Item$(i)) < 14 THEN
           ItemLength = 14
        END IF
    NEXT i

'*******************************************
'***** build frame around choices **********
'*******************************************
      
    LtCol = Col - 1
    RtCol = Col + ItemLength
    COLOR 0, 7

    LOCATE Row - 1, LtCol
    PRINT CHR$(218);
    FOR i = 1 TO ItemLength     '**** top of frame ****
        PRINT CHR$(196);
    NEXT i
    PRINT CHR$(191)
 
    LOCATE Row, 1
    FOR i = 1 TO MaxItems    '***  print menu items and frame sides **
        LOCATE , LtCol
        PRINT CHR$(179); TAB(RtCol); CHR$(179)
    NEXT i

    LOCATE Row + MaxItems, LtCol
    PRINT CHR$(192);
    FOR i = 1 TO ItemLength      '*** bottom1 of frame ****
        PRINT CHR$(196);
    NEXT i
    PRINT CHR$(217);
    Shade Row - 1, LtCol, Row + MaxItems, RtCol

'*******************************************
'******** print selections and *************
'******** pointer **************************
'*******************************************

    LOCATE Row
    FOR i = 1 TO MaxItems
        LOCATE Row + i - 1, Col
        PRINT Item$(i)
    NEXT i

    DO
        COLOR 7, 0       '************************* Hilite color
     
        LOCATE Row + ItemNum - 1, Col
        Item$(ItemNum) = Item$(ItemNum) + SPACE$(ItemLength - LEN(Item$(ItemNum)))
        PRINT Item$(ItemNum)

        COLOR 0, 7       '******* back to normal item color

'*******************************************
'***** Start picking up the keystrokes *****
'*******************************************

        DO WHILE ch$ = ""
            ch$ = UCASE$(INKEY$)
        LOOP
        Kee = ASC(ch$)
        IF ASC(ch$) = 0 THEN
            Kee = ASC(RIGHT$(ch$, 1))
        END IF

        LOCATE Row + ItemNum - 1, Col
        PRINT Item$(ItemNum)
       
        SELECT CASE Kee
            CASE F1
                Help HelpStr$()
            CASE LeftArrow
                movekey = -1
                EXIT SUB
            CASE RightArrow
                movekey = 1
                EXIT SUB
            CASE Home
                ItemNum = 1
            CASE EndKey
                ItemNum = MaxItems
            CASE UpArrow
                IF ItemNum > 1 THEN
                    ItemNum = ItemNum - 1
                ELSE
                    ItemNum = MaxItems
                END IF
            CASE DownArrow
                IF ItemNum < MaxItems THEN
                    ItemNum = ItemNum + 1
                ELSE
                    ItemNum = 1
                END IF
            CASE Enter
                fore = 0
                back = 7
                FOR i = 1 TO 6
                    COLOR fore, back
                    IF fore = 7 THEN
                        fore = 0: back = 7
                    ELSE
                        fore = 7: back = 0
                    END IF
                    LOCATE Row + ItemNum - 1, Col
                    Item$(ItemNum) = Item$(ItemNum) + SPACE$(ItemLength - LEN(Item$(ItemNum)))
                    PRINT Item$(ItemNum)
                    Pause 1
                NEXT
                EXIT DO
            CASE Escape
                trigger = 0
                ItemNum = 0
                startpos = 1
                EXIT DO
            CASE ELSE
                Burp
        END SELECT
        ch$ = ""
    LOOP
    ClearKbd
'
END SUB

SUB Pause (ticks)
    DEF SEG = 0
    DO UNTIL TestTick > ticks
        IF LEN(INKEY$) THEN EXIT SUB
        LastTick = GetTick
        GetTick = PEEK(&H46C)
        IF LastTick <> GetTick THEN
            TestTick = TestTick + 1
        END IF
    LOOP
    DEF SEG
END SUB

SUB PokeBar

    DEF SEG = &H40
    equip = PEEK(&H10)
    IF (equip AND 48) = 48 THEN
        DEF SEG = &HB000
    ELSE
        DEF SEG = &HB800
    END IF

    Row = 1

    FOR column = 1 TO 80
        offset = (Row - 1) * 160 + (column - 1) * 2 + 1
        POKE offset, 112
    NEXT
    DEF SEG
END SUB

SUB RestScrn (Scr())
    DEF SEG = &H40
    equip = PEEK(&H10)
    IF (equip AND 48) = 48 THEN
        ToSeg = &HB000
    ELSE
        ToSeg = &HB800
    END IF
    FrSeg = VARSEG(Scr(1))
    FrOffs = VARPTR(Scr(1))
    ' For QB internal MemCopy
    MemCopy FrSeg, FrOffs, ToSeg, 0, 4000
    'For my MemCopy
    'MemCopy FrSeg, FrOffs, ToSeg, 0, 4000
END SUB

SUB SaveScrn (Scr())
    DEF SEG = &H40
    equip = PEEK(&H10)
    IF (equip AND 48) = 48 THEN
        FrSeg = &HB000
    ELSE
        FrSeg = &HB800
    END IF
    ToSeg = VARSEG(Scr(1))
    ToOffs = VARPTR(Scr(1))
    ' For QB internal MemCopy
    MemCopy FrSeg, 0, ToSeg, ToOffs, 4000
    'For my MemCopy
    'MemCopy FrSeg, 0, ToSeg, ToOffs, 4000
END SUB

SUB ScrollBox (Row, Col, Item$(), ItemNum, MaxItems, OnScreen, movekey)
SHARED trigger, startpos

    DIM HelpStr$(1 TO 5)
    HelpStr$(1) = "Use the up and down arrow keys to move between"
    HelpStr$(2) = "selections.  Press <ENTER> to select.  Press <HOME>"
    HelpStr$(3) = "and <END> to jump to the beginning or end of the list"
    HelpStr$(4) = "respectively.  Press <ESC> to cancel."
    Row = Row + 1
    Col = Col + 1
    ItemNum = 1
    ItemLength = 1
    FOR i = 1 TO MaxItems
    IF LEFT$(Item$(i), 1) <> " " THEN
        Item$(i) = " " + Item$(i) + " "
    END IF
    NEXT i
    FOR i = 1 TO MaxItems
        IF LEN(Item$(i)) > ItemLength THEN
            ItemLength = LEN(Item$(i))
        ELSEIF LEN(Item$(i)) < 14 THEN
            ItemLength = 14
        END IF
    NEXT i

'*******************************************
'***** build frame around choices **********
'*******************************************
      
    LtCol = Col - 1
    RtCol = Col + ItemLength
   
    COLOR 0, 7

    LOCATE Row - 1, LtCol
    PRINT CHR$(218);
    FOR i = 1 TO ItemLength     '**** top of frame ****
        PRINT CHR$(196);
    NEXT i
    PRINT CHR$(191)
 
    LOCATE Row, 1
    FOR i = 1 TO OnScreen    '***  print menu items and frame sides **
        LOCATE , LtCol
        PRINT CHR$(179); TAB(RtCol); CHR$(179)
    NEXT i

    LOCATE Row + OnScreen, LtCol
    PRINT CHR$(192);
    FOR i = 1 TO ItemLength      '*** bottom1 of frame ****
        PRINT CHR$(196);
    NEXT i
    PRINT CHR$(217);
    Shade Row - 1, LtCol, Row + OnScreen, RtCol

'*******************************************
'******** print selections and *************
'******** pointer **************************
'*******************************************
    LtCol = LtCol + 1
    RtCol = RtCol - 1
    low = 1
    MaxItems = MaxItems + 1
   
    DO
         LOCATE 1, 1
         IF low <> OldLow THEN
            LOCATE Row
            FOR i = low TO (OnScreen + low) - 1
               LOCATE Row + (i - low), Col
               PRINT Item$(i)
            NEXT i
         END IF
         OldLow = low
         ChangeRowColor Row - 1 + ItemNum, LtCol, RtCol, 7
'*******************************************
'***** Start picking up the keystrokes *****
'*******************************************

        DO WHILE ch$ = ""
            ch$ = UCASE$(INKEY$)
        LOOP
        Kee = ASC(ch$)
        IF ASC(ch$) = 0 THEN
            Kee = ASC(RIGHT$(ch$, 1))
        END IF

        ChangeRowColor Row - 1 + ItemNum, LtCol, RtCol, 112
        SELECT CASE Kee
            CASE F1
                Help HelpStr$()
            CASE LeftArrow
                movekey = -1
                EXIT DO
            CASE RightArrow
                movekey = 1
                EXIT DO
            CASE Home
                ItemNum = 1
                low = 1
            CASE EndKey
                ItemNum = OnScreen
                low = MaxItems - OnScreen
            CASE UpArrow
                IF ItemNum > 1 THEN
                    ItemNum = ItemNum - 1
                ELSE
                    IF low = 1 THEN
                        Burp
                    ELSE
                        low = low - 1
                    END IF
                END IF
            CASE DownArrow
                IF ItemNum < OnScreen THEN
                    ItemNum = ItemNum + 1
                ELSE
                    IF low + OnScreen = MaxItems THEN
                        Burp
                    ELSE
                        low = low + 1
                    END IF
                END IF
            CASE Enter
                fore = 0
                back = 7
                TheItem = low + ItemNum - 1
                FOR i = 1 TO 6
                    COLOR fore, back
                    IF fore = 7 THEN
                        fore = 0: back = 7
                    ELSE
                        fore = 7: back = 0
                    END IF
                    LOCATE Row + ItemNum - 1, Col
                    Item$(TheItem) = Item$(TheItem) + SPACE$(ItemLength - LEN(Item$(TheItem)))
                    PRINT Item$(TheItem)
                    Pause 1
                NEXT
                EXIT DO
            CASE Escape
                trigger = 0
                ItemNum = 0
                startpos = 1
                EXIT DO
            CASE ELSE
                Burp
        END SELECT
        ch$ = ""
    LOOP
    MaxItems = MaxItems - 1
    ClearKbd
    ItemNum = ItemNum + low - 1
END SUB

SUB Shade (Uprow, LtCol, Lorow, RtCol)
    DEF SEG = &H40
    equip = PEEK(&H10)
    IF (equip AND 48) = 48 THEN
        EXIT SUB
    ELSE
        DEF SEG = &HB800
    END IF
    FOR vert = Uprow + 1 TO Lorow + 1
        FOR Height = RtCol + 1 TO RtCol + 2
            offset = (vert - 1) * 160 + (Height - 1) * 2 + 1
            POKE offset, 8
        NEXT
    NEXT
    vert = Lorow + 1
    FOR Height = LtCol + 2 TO RtCol + 2
        offset = (vert - 1) * 160 + (Height - 1) * 2 + 1
        POKE offset, 8
    NEXT
    DEF SEG
END SUB

SUB TextBox (Txt$(), Row%, Col%, OnScreen%, Wid, StartLine%, ExitKey$)
   COLOR 0, 7
   DIM TextScr(1 TO 2000)
   SaveScrn TextScr()
   DIM HelpStr$(1 TO 7)
   HelpStr$(1) = " Use the up and down arrow keys to scroll"
   HelpStr$(2) = " the text up or down respectively.  Use the"
   HelpStr$(3) = " right and left keys to move the text side"
   HelpStr$(4) = " to side.  <PgUP> and <PgDN> move the text"
   HelpStr$(5) = " up or down an entire page.  <HOME> and <END>"
   HelpStr$(6) = " jump to the beginning or end of the text."
   HelpStr$(7) = " <ESC> cancels."

   Upper% = UBOUND(Txt$)
   Lower% = LBOUND(Txt$)
   OnScreen% = OnScreen% - 1
   Height = OnScreen% + 2
   FOR i = Lower% TO Upper%
      l = LEN(Txt$(i))
      IF l > MaxCol THEN MaxCol = l
   NEXT i
   FOR i = Lower% TO Upper%
      l = LEN(Txt$(i))
      Txt$(i) = Txt$(i) + STRING$(MaxCol - l, 32)
   NEXT
   IF Wid = 0 THEN
      'Wid = Wid + 3
      Wid = MaxCol
      IF Wid > 78 THEN Wid = 78
   END IF
   DrawBox Row%, Col%, Height, Wid
   Shade Row%, Col%, Row + Height, Col% + Wid + 1
   IF Row% = 0 THEN Row% = ((25 - Height%) \ 2) + 1
   IF Col% = 0 THEN Col% = Center%(Txt$(StrNum))
   Lne% = StartLine%
   Lower% = Lower% - 1
   StrCol% = 1
   DO
      l = Lne%
      FOR i = (Row% + 1) TO (Row% + 1) + OnScreen%
         l = l + 1
         LOCATE i, Col% + 1
         PRINT MID$(Txt$(l), StrCol%, Wid)
      NEXT i

      DO
         K$ = INKEY$
      LOOP UNTIL LEN(K$)
      SELECT CASE K$
         CASE CHR$(0) + CHR$(F1)
            Help HelpStr$()
         CASE CHR$(0) + CHR$(CtrlHome)
            Lne% = Lower%
         CASE CHR$(0) + CHR$(CtrlEnd)
            Lne% = Upper% - OnScreen% - 1
         CASE CHR$(0) + CHR$(PageDown)
            Lne% = Lne% + OnScreen% - 1
            IF Lne% > Upper% - OnScreen - 1 THEN Lne% = Upper% - OnScreen - 1
         CASE CHR$(0) + CHR$(PageUp)
            Lne% = Lne% - OnScreen%
            IF Lne% < Lower% THEN Lne% = Lower%
         CASE CHR$(0) + CHR$(Home)
            StrCol% = 1
         CASE CHR$(0) + CHR$(EndKey)
            StrCol% = MaxCol% - Wid% + 1
            IF StrCol% < 1 THEN StrCol% = 1
         CASE CHR$(0) + CHR$(UpArrow)
            Lne% = Lne% - 1
            IF Lne% < Lower% THEN
               Lne% = Lower%
               Burp
            END IF
         CASE CHR$(0) + CHR$(DownArrow)
            Lne% = Lne% + 1
            IF Lne% > Upper% - OnScreen% - 1 THEN
               Lne% = Upper% - OnScreen% - 1
               Burp
            END IF
         CASE CHR$(0) + CHR$(LeftArrow)
            StrCol% = StrCol% - 5
            IF StrCol% < 1 THEN
               StrCol% = 1
               Burp
            END IF
         CASE CHR$(0) + CHR$(RightArrow)
            StrCol% = StrCol% + 5
            IF StrCol% > MaxCol% - Wid + 1 THEN
               StrCol% = MaxCol% - Wid + 1
               Burp
            END IF
            IF StrCol% < 1 THEN StrCol% = 1
         CASE ELSE
            ExitKey$ = K$
            StartLine% = Lne%
            EXIT DO
      END SELECT
   LOOP
   RestScrn TextScr()
END SUB

FUNCTION YesNoBox (Txt$(), Row, Col, Default)
   DIM YesNoScr(1 TO 2000)
   CALL SaveScrn(YesNoScr())
   Upper% = UBOUND(Txt$)
   Lower% = LBOUND(Txt$)
   COLOR 0, 7
   Height = Upper% - Lower% + 2
   FOR i = Lower% TO Upper%
      l = LEN(Txt$(i))
      IF l > Wid THEN Wid = l
   NEXT i
   IF Wid < 22 THEN Wid = 22
   Wid = Wid + 3
   DrawBox Row%, Col%, Height + 3, Wid
   Shade Row%, Col%, Row + Height + 3, Col% + Wid + 1
   IF Row% = 0 THEN Row% = ((25 - Height%) \ 2) + 1
   IF Col% = 0 THEN Col% = Center%(Txt$(StrNum))
   FOR i = Row% + 1 TO (Row% + 1) + (Upper% - Lower%)
      StrNum = StrNum + 1
      LOCATE i, Col% + 1
      PRINT Txt$(StrNum);
   NEXT i
   R = (Row% + 3) + (Upper% - Lower%)
   LOCATE R, Col%
   PRINT CHR$(195) + STRING$(Wid, 196) + CHR$(180);
   LOCATE R + 1, Col% + 1
   PRINT "    Yes        No     "
   Cursor = Default
   DO
      IF Cursor THEN COLOR 15, 7
      LOCATE R + 1, Col% + 3
      PRINT "<";
      LOCATE , Col% + 9
      PRINT ">";
      COLOR 0, 7
      IF NOT Cursor THEN COLOR 15, 7
      LOCATE R + 1, Col% + 14
      PRINT "<";
      LOCATE , Col% + 20
      PRINT ">";
      COLOR 0, 7
      DO
         K$ = INKEY$
      LOOP UNTIL LEN(K$)
      SELECT CASE K$
         CASE CHR$(13)
            YesNoBox = Cursor
            EXIT DO
         CASE CHR$(9)
            Cursor = NOT (Cursor)
         CASE "Y", "y"
            YesNoBox = -1
            EXIT DO
         CASE "N", "n"
            YesNoBox = 0
            EXIT DO
      END SELECT
   LOOP

   CALL RestScrn(YesNoScr())
  
END FUNCTION

