DEFINT A-Z

'$INCLUDE: 'QWK.BI'
'$INCLUDE: 'FIDO.BI'
'$INCLUDE: 'MISC.BI'
'$DYNAMIC

DECLARE SUB CloseControl ()
DECLARE FUNCTION ValidateQWKName$ ()
DECLARE FUNCTION HasExtension (FileName$)
DECLARE FUNCTION DIR$ (FileSpec$)
DECLARE FUNCTION AreaTags$ ()
DECLARE SUB Unarchive (FileName AS STRING)
DECLARE SUB ReadControl (BBSID$, NumberOfAreas, NumberOfMessages)
DECLARE SUB MakePacket (A AS Address, password AS STRING)
DECLARE SUB ConvertQWK2PKT (BBSID$, NumberOfMessages, AreaNames() AS STRING, A AS Address)
DECLARE SUB ReadQWK (Q AS ANY, Text$)
DECLARE SUB OpenQWK ()
DECLARE FUNCTION Convert2FidoText$ (Text$, AreaName$)
DECLARE FUNCTION NameCase$ (Name$)
DECLARE SUB CloseQWK ()
DECLARE SUB AddMessageToPacket (From$, FA AS ANY, ToName$, TA AS ANY, Subject$, Text$, T AS ANY)
DECLARE SUB CreatePacket (Ph AS FSC0039)
DECLARE SUB ClosePacket ()
DECLARE FUNCTION TranslateConference (Conference)

FileName$ = ValidateQWKName$
IF LEN(DIR$(FileName$)) = 0 THEN              'File doesn't exist!
   PRINT : PRINT "File " + FileName$ + " does not exist!"
   END
END IF

Unarchive (FileName$)

ReadControl BBSID$, NumberOfAreas, NumberOfMessages
DIM AreaNames(0 TO NumberOfAreas) AS STRING
FOR A = 0 TO NumberOfAreas
   AreaNames(A) = AreaTags$
NEXT A
CloseControl
DIM Add AS Address
PRINT FREEFILE
ConvertQWK2PKT BBSID$, NumberOfMessages, AreaNames(), Add

END

REM $STATIC
SUB ConvertQWK2PKT (BBSID$, NumberOfMessages, AreaNames() AS STRING, Add AS Address)
   DIM Q AS QwkHeader            'dimmensionalize a QWK message header
   DIM T AS TimeStruct
   CLOSE
   PRINT FREEFILE
   MakePacket Add, ""
   OpenQWK                       'start-up the QWK routines
   WHILE LOC(1) < LOF(1) \ 128
      ReadQWK Q, Qtext$             'read the next message in the QWK file
      Q.ConferenceNum = TranslateConference(Q.ConferenceNum)
      Text$ = Convert2FidoText$(Qtext$, AreaNames(Q.ConferenceNum))   'convert the text part
                                 'of the last QWK message read in to a format
                                 'that will make FidoNet<TM> happy.
      From$ = NameCase$(RTRIM$(Q.From)) + CHR$(0)  'convert the QWK From:
                                 'name to mixed-case, also trims the spaces
                                 'off of the right side and adds a NULL
      ToName$ = NameCase$(RTRIM$(Q.ToName)) + CHR$(0) 'same as above
      Subject$ = RTRIM$(Q.Subject) + CHR$(0)
      AddMessageToPacket From$, Add, ToName$, Add, Subject$, Text$, T
         'Add this message to the .PKT
   WEND

   CloseQWK
   ClosePacket
   
   PRINT "File converted!"

END SUB

DEFSNG N-Z
SUB MakePacket (A AS Address, password AS STRING)
   DIM P AS FSC0039
   P.origZone = 1
   P.QorigZone = 1
   P.OrigNet = 999
   P.OrigNode = 999
   P.origPoint = 0
   P.destZone = A.Zone
   P.QdestZone = A.Zone
   P.DestNet = A.Net
   P.DestNode = A.Node
   P.destPoint = A.Pnt
   P.year = VAL(RIGHT$(DATE$, 2))
   P.month = VAL(LEFT$(DATE$, 2))
   P.day = VAL(MID$(DATE$, 4, 2))
   P.hour = VAL(LEFT$(TIME$, 2))
   P.minute = VAL(MID$(TIME$, 4, 2))
   P.second = VAL(RIGHT$(TIME$, 2))
   P.Baud = 0
   P.Version = 2
   P.PodCodeLow = CHR$(0)
   P.PodCodeHigh = CHR$(0)
   P.MajorLvl = CHR$(1)
   P.MinorLvl = CHR$(0)
   P.password = LTRIM$(LEFT$(password, 8))
   'P.Terminator = 0
   CreatePacket P
END SUB

DEFINT N-Z
FUNCTION ValidateQWKName$
   Cmnd$ = LTRIM$(RTRIM$(COMMAND$))
   IF NOT HasExtension(Cmnd$) THEN
      Cmnd$ = Cmnd$ + ".QWK"
   END IF
   ValidateQWKName$ = Cmnd$
END FUNCTION

