; SCR2ARRY.ASM  12-4-92  by Matt Hart
;
; Reads the screen into an array
; DECLARE SUB ReadScreen(SEG Array%(), BYVAL ScrSeg%)
;   ReadScreen reads the screen attributes and characters
;   At 80x25 x 2bytes = 4000 bytes = 2000 integer array elements
;   REDIM Array%(1 TO 2000)
;
; DECLARE SUB ReadScrChars(SEG Strg(), BYVAL ScrSeg%)
;   ReadScrChars will load a string with the chars - which is
;   handy for doing an INSTR and looking for something on the
;   screen
;   REDIM Strg(1 TO 1) AS STRING * 2000
;
; For the ScrSeg%, use &HB000 for monochrome and &HB800 as color
;
; Use MASM 5.0:
;       C:\>masm scr2arry.asm
; or MASM 6.0:
;       C:\>ml /c scr2arry.asm
; and LINK to your program:
;       C:\>link myprog+scr2arry,,,brun45;
;
.MODEL MEDIUM,BASIC
.CODE
ReadScreen PROC ArraySeg:DWord, ScrSeg:Word
    LES     DI,ArraySeg     ; Address of storage array
    MOV     AX,ScrSeg       ; Screen segment
    MOV     DS,AX           ; Scr Seg into DS
    MOV     SI,0            ; Offset starting at 0
    MOV     CX,2000         ; 2000 moves of 2 bytes
    REP     MOVSW           ; Move 2 bytes from DS:SI to ES:DI
                            ; for CX times
    RET                     ; Back to BASIC
ReadScreen ENDP

ReadScrChars PROC StrgSeg:DWord, ScrSeg:Word
    LES     DI,StrgSeg      ; Address of storage string
    MOV     AX,ScrSeg       ; Screen segment
    MOV     DS,AX           ; Scr Seg into DS
    MOV     SI,0            ; Offset starting at 0
    MOV     CX,2000         ; 2000 moves of 1 byte
TopLoop:
    MOV     DS:[SI],AL      ; A character into AL
    MOV     AL,ES:[DI]      ; Move it into the string
    INC     SI              ; Increment to attribute
    INC     SI              ; Next char
    INC     DI              ; Next string address
    LOOP    TopLoop         ; Continue for CX times
ReadScrChars ENDP
END
