DEFINT A-Z
CONST False% = 0, True% = NOT False%
DECLARE FUNCTION FileRoot$ (FileName$)
DECLARE FUNCTION Exists% (FileName$)
DECLARE FUNCTION TRIM$ (Text$)
DECLARE SUB Comline (NumArgs%, Arg$(), MaxArgs%)
DECLARE SUB Help ()
DIM Arg$(1 TO 2)

    Comline NumArgs%, Arg$(), 2
    InFile$ = Arg$(1)
    Maxlines% = VAL(Arg$(2))
    IF Maxlines% < 10 OR Maxlines% > 100 THEN
        PRINT
        PRINT "Bad or missing parameters."
        Help
    END IF
    found% = Exists%(InFile$)
    IF InFile$ = "" THEN Help
    IF NOT found% THEN
        PRINT
        PRINT "Input file was not found."
        Help
    END IF

    ON ERROR GOTO Done

    InFileRoot$ = FileRoot$(InFile$)
    
    OPEN InFile$ FOR INPUT AS #1

    PRINT : PRINT : PRINT : PRINT

    row% = CSRLIN
    nextmsg% = False%
    DO UNTIL EOF(1)
        FileExt% = FileExt% + 1
        IF FileExt% < 9 THEN
            OutFile$ = InFileRoot$ + ".00" + TRIM$(STR$(FileExt%))
        ELSEIF FileExt% > 9 AND FileExt% < 100 THEN
            OutFile$ = InFileRoot$ + ".0" + TRIM$(STR$(FileExt%))
        ELSE
            BEEP
            PRINT
            PRINT "C'mon already... this post is way too big,"
            PRINT "slap a stamp on it and send it snail-mail!"
            END
        END IF
        OPEN OutFile$ FOR OUTPUT AS #2
        IF nextmsg% THEN
            PRINT #2, " >>> continued from the previous message"
            PRINT #2,
        END IF
        LOCATE row% - 2, 1
        PRINT InFile$; " is now being broken into"; FileExt%; "files"
        Max% = Maxlines% - 4
        FOR x% = 1 TO Max%
            LOCATE row%, 1
            PRINT "Line: ";
            PRINT USING "###"; x%;
            LINE INPUT #1, ILine$
            PRINT #2, ILine$
        NEXT
        IF NOT EOF(1) THEN
            PRINT #2,
            PRINT #2, " >>> continued to the next message"
        END IF
        CLOSE #2
        nextmsg% = True%
    LOOP

Done:

    SELECT CASE ERR
        CASE 62, 0
            CLOSE
            LOCATE row%, 1
            PRINT "Finished!"; SPC(10);
            PRINT : PRINT
            PRINT "Your complete message is now ready to be uploaded as a series"
            PRINT "of"; FileExt%; "consecutive posts, each a maximum of"; Maxlines%; "lines in length."
            PRINT
            FOR i% = 1 TO FileExt%
                Ext% = INSTR(OutFile$, ".")
                PRINT SPC(5); FileRoot$(OutFile$); ".";
                IF FileExt% < 9 THEN
                    PRINT "00";
                ELSE
                    PRINT "0";
                END IF
                PRINT TRIM$(STR$(i%))
            NEXT
        CASE ELSE
            PRINT "An error occurred creating the file(s)"
    END SELECT
    END

SUB Comline (NumArgs%, Arg$(), MaxArgs%) STATIC

'**** Yup, this is the same command line parser from the QB examples

    NumArgs% = 0: In% = False: Cl$ = COMMAND$: length% = LEN(Cl$)
    FOR i% = 1 TO length%
        C$ = MID$(Cl$, i%, 1)
        IF (C$ <> " " AND C$ <> CHR$(9) AND C$ <> "/" AND C$ <> ",") THEN
            IF NOT In% THEN
                IF NumArgs% = MaxArgs% THEN EXIT FOR
                NumArgs% = NumArgs% + 1
                In% = True
            END IF
                Arg$(NumArgs%) = Arg$(NumArgs%) + C$
        ELSE
            In% = False
        END IF
    NEXT i%
END SUB

FUNCTION Exists% (FileName$)
    IF LEN(DIR$(FileName$)) = 0 THEN
        Exists% = 0
    ELSE
        Exists% = -1
    END IF
END FUNCTION

FUNCTION FileRoot$ (FileName$) STATIC
    Ext% = INSTR(FileName$, ".")
    IF Ext% > 0 THEN
        FileRoot$ = LEFT$(FileName$, Ext% - 1)
    ELSE
        FileRoot$ = FileName$
    END IF
END FUNCTION

SUB Help
    BEEP
    PRINT
    PRINT "Usage: Splitmsg <filename.ext> <n>"
    PRINT
    PRINT "where filename.ext is an ascii text message to be split"
    PRINT "for use in FidoNET and n is the maximum number of lines "
    PRINT "per post. Note: n must be between 10 and 100 lines."
    END
END SUB

FUNCTION TRIM$ (Text$) STATIC
    length% = 1
    WHILE length% <= LEN(Text$) AND MID$(Text$, length%, 1) = " "
        length% = length% + 1
    WEND
    Text$ = MID$(Text$, length%)
    length% = LEN(Text$)
    IF length% = 0 THEN
        TRIM$ = ""
        EXIT FUNCTION
    END IF
    WHILE length% <> 0 AND MID$(Text$, length%, 1) = " "
        length% = length% - 1
    WEND
    Text$ = LEFT$(Text$, length%)
    TRIM$ = Text$
END FUNCTION

