DECLARE FUNCTION Month$ (MonthNo%)
DECLARE FUNCTION ConvertChars$ (Text$, Char1 AS STRING, Char2 AS STRING)
DECLARE FUNCTION StripHighASCII$ (Text$)
DECLARE FUNCTION StripControlCodes$ (Text$)
DECLARE FUNCTION ConverrtChars$ (Text$, Char1%, Char2%)
DECLARE FUNCTION NameCase$ (Nme$)
DEFINT A-Z
'$DYNAMIC

REM $STATIC
FUNCTION ConvertChars$ (Text$, Char1 AS STRING, Char2 AS STRING)
   'converts all occurences of Char1 to Char2 in Text$ and returns the
   'result.
   T$ = Text$                          'copy Text$ to T$ so we don't change
                                       'it
   FOR A = 1 TO LEN(T$)                'go throught the whole string byte
      IF MID$(T$, A, 1) = Char1 THEN   'by byte and change all occurences
         MID$(T$, A, 1) = Char2        'of Char1 to Char2
      END IF
   NEXT A
   ConvertChars$ = T$

END FUNCTION

FUNCTION Month$ (MonthNo%)
   SELECT CASE MonthNo%
      CASE 1
         Month$ = "January"
      CASE 2
         Month$ = "February"
      CASE 3
         Month$ = "March"
      CASE 4
         Month$ = "April"
      CASE 5
         Month$ = "May"
      CASE 6
         Month$ = "June"
      CASE 7
         Month$ = "July"
      CASE 8
         Month$ = "August"
      CASE 9
         Month$ = "September"
      CASE 10
         Month$ = "October"
      CASE 11
         Month$ = "November"
      CASE 12
         Month$ = "December"
      CASE ELSE
         Month$ = "ERROR"
   END SELECT
END FUNCTION

FUNCTION NameCase$ (Nme$)
   'This routine adapted from NCase$ in Jeff Freeman's
   'JDIDoor door routines.  Thanks Jeff!
   Name$ = Nme$
   Name$ = RTRIM$(LCASE$(Name$))
   IF Name$ = CHR$(0) THEN EXIT FUNCTION
   MID$(Name$, 1, 1) = UCASE$(LEFT$(Name$, 1))
   FOR X = 1 TO LEN(Name$)
      IF MID$(Name$, X, 1) = CHR$(32) THEN
         MID$(Name$, X + 1, 1) = UCASE$(MID$(Name$, X + 1, 1))
      END IF
   NEXT X
   NameCase$ = Name$
END FUNCTION

FUNCTION StripControlCodes$ (Text$)
   'takes out ALL occurences of control codes (chars < 32), skips <CR>s
   DIM Char AS STRING
   FOR A = 1 TO LEN(Text$)
      Char = MID$(Text$, A, 1)      'Get a character from the string
      IF ASC(Char) >= 32 OR Char = CHR$(13) THEN
         T$ = T$ + Char             'Copy the byte to the new string ONLY IF
      END IF                        'it isn't a control character
   NEXT A
   StripContrilCodes$ = T$
END FUNCTION

FUNCTION StripHighASCII$ (Text$)
   'Converts all high ASCII characters ( > 127) to spaces
   'This is going to look REAL similar to ConvertChars
  
   T$ = Text$                          'copy Text$ to T$ so we don't change
                                       'it
   FOR A = 1 TO LEN(T$)                'go throught the whole string byte
      IF ASC(MID$(T$, A, 1)) > 127 THEN 'by byte and change all occurences
         MID$(T$, A, 1) = CHR$(32)      'high ASCII to CHR$(32)
      END IF
   NEXT A
   StripHighASCII$ = T$

END FUNCTION

