'*********************************************************
'**** TAGMENU2.BAS, a revision of TagMenu by Ray Carson **
'**** Revisions and window open and close sounds *********
'**** by Mark H Butler June 1992 *************************
'**** Windowing routines by Christy Gemmel as seen *******
'**** in QBNWS204 ( QBNews volume #2, issue # 4 ) ********
'**** Window and Sound routines are in TAG7.LIB and ******
'**** TAG45.LIB. Can be run under QB45 or PDS7 ***********
'*********************************************************
DEFINT A-Z
'$INCLUDE: 'windecs.bi'
DECLARE FUNCTION KeyCode% ()
DECLARE SUB TagMenu (UpRow%, LtCol, LoRow%, FgNorm%, BgNorm%, FgHilit%, BgHilit%, FgTag%, Kee%, N, QtySelected%, Item$(), Tagged%(), Snd%)
DECLARE SUB DeskTop ()

    REDIM Item$(50), Tagged%(50)
    FOR ItemNum% = 1 TO 50
        Item$(ItemNum%) = "Menu Item #" + STR$(ItemNum%)
    NEXT
    MaxItems% = 50

    LOCATE , , 0

    DeskTop
    SLEEP 2
    
    Snd% = -1  '*** This new parameter has been added to TagMenu's
               '*** parameter list. The -order- of passed parameters
               '*** was also changed to accomodate other code I have
               '*** that wants window, shadow etc locations passed in
               '*** the order -> UpRow%, LtCol%, LoRow%
               '*** The Snd% parameter is boolean; 0 = no sounds
               '***                               -1 = sounds on

    CALL TagMenu(5, 32, 15, 0, 7, 7, 0, 4, Kee%, MaxItems%, QtySelected%, Item$(), Tagged%(), Snd%)

    SLEEP 2

    COLOR 7, 0: CLS
    IF Kee% = 27 THEN PRINT "User Aborted": END
    PRINT LTRIM$(STR$(QtySelected%)); " items selected:"
    FOR ItemNum% = 1 TO MaxItems%
        IF Tagged%(ItemNum%) THEN
            LOCATE , 5
            PRINT Item$(ItemNum%)
        END IF
    NEXT
    END
'**** **** **** **** **** **** ****
'**** **** **** **** **** **** ****

SUB DeskTop STATIC
    Matt$ = STRING$(2000, "")
    Attr% = Attribute%(7, 1)
    FastPrint 1, 1, Matt$, Attr%
END SUB

FUNCTION KeyCode% STATIC
        DO
                K$ = INKEY$
        LOOP UNTIL K$ <> ""
        KeyCode% = CVI(K$ + CHR$(0))
END FUNCTION

SUB TagMenu (UpRow%, LtCol%, LoRow%, FgNorm%, BgNorm%, FgHilit%, BgHilit%, FgTag%, Kee%, MaxItems%, QtySelected%, Item$(), Tagged%(), Snd%)
CONST Enter% = 13, Escape% = 27, UpArrow% = 18432
CONST DnArrow% = 20480, F10% = 17408
CONST F2% = 15360, F3% = 15616, Home% = 18176
CONST EndKey% = 20224, SpaceBar% = 32

    untagged% = -1
    SelectChar$ = CHR$(16)
    MaxLength% = 0
    FOR ItemNum% = 1 TO MaxItems%
        Q% = LEN(Item$(ItemNum%))
        IF Q% > MaxLength% THEN MaxLength% = Q%
    NEXT ItemNum%
    COLOR FgNorm%, BgNorm%
    LOCATE 25, 1
    PRINT SPACE$(80);
    LOCATE 25, 2
    PRINT "Home End "; CHR$(25); CHR$(24); "  Tag/Untag [Sp]["; CHR$(17); "] Tag All [F2] Clear Tags [F3] Accept [F10]";
    UR% = UpRow% - 1
    LR% = LoRow% + 1
    LC% = LtCol% - 2
    RC% = LtCol% + MaxLength% + 3
    Wdth% = RC% - LC% + 1
    Hght% = LR% - UR% + 1
    Attr% = Attribute%(FgNorm%, BgNorm%)
    Brdr% = 1
    Shdw% = 4

    '** If Snd% = -1 (true) then window will explode onto the screen
    '** with a sound
    IF Snd% THEN CALL Phweep
    PopUp UR%, LC%, Hght%, Wdth%, Attr%, Brdr%, Shdw%, Zoom%


SetupTagMenu:
    row% = UpRow%
    Column% = LtCol%
    COLOR FgNorm%, BgNorm%
    ItemNum% = 1
    DO
        LOCATE row%, Column%
        PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";
        RowI% = row%
        GOSUB CheckTagged
        row% = row% + 1
        IF row% = LoRow% + 1 THEN EXIT DO
        ItemNum% = ItemNum% + 1
    LOOP UNTIL ItemNum% > MaxItems%
    row% = UpRow%
    ItemNum% = 1
    COLOR FgHilit%, BgHilit%
    LOCATE row%, Column%
    PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";

    DO
        Kee% = KeyCode%
        SELECT CASE Kee%
        CASE F10%, Escape%                        'F10 or Escape
            IF Snd% THEN CALL Phwoop   '<-- window closing sound
            Shutup -1     '<-- window implode. Just like DO/LOOP
            EXIT SUB      'FOR/NEXT etc there needs to be a
                          '"Shutup" for every call to "Popup"
                          'or b-a-d things will happen!
        CASE F2%                                  'F2 - tag all
            IF Snd% AND untagged% THEN CALL Pip
            '                               ^^^
            '** a "pip" sound when tagging --'
            '
            QtySelected% = MaxItems%
            FOR Q% = 1 TO MaxItems%
                Tagged%(Q%) = -1
            NEXT Q%
            COLOR FgTag%, BgNorm%
            FOR Q% = UpRow% TO LoRow%
                IF SCREEN(Q%, Column% + 1) <> 32 THEN
                    LOCATE Q%, Column% - 1
                    PRINT SelectChar$;
                END IF
            NEXT
            istagged% = -1
            untagged% = 0
        CASE F3%                                 'F3 - Clear all tags
            IF Snd% AND istagged% THEN CALL Pip
            QtySelected% = 0
            FOR Q% = 1 TO MaxItems%
                Tagged%(Q%) = 0
            NEXT Q%
            COLOR FgNorm%, BgNorm%
            FOR Q% = UpRow% TO LoRow%
                LOCATE Q%, Column% - 1
                PRINT " ";
            NEXT
            untagged% = -1
            istagged% = 0
        CASE Home%                                'Home
            GOTO SetupTagMenu
        CASE EndKey%                              'End
            COLOR FgNorm%, BgNorm%
            LOCATE row%, Column%
            PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";
            row% = UpRow%
            ItemNum% = MaxItems% - (LoRow% - UpRow%)
            IF ItemNum% < 1 THEN ItemNum% = 1
            DO
                LOCATE row%, Column%
                PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";
                RowI% = row%
                GOSUB CheckTagged
                row% = row% + 1
                IF row% = LoRow% + 1 THEN EXIT DO
                ItemNum% = ItemNum% + 1
            LOOP UNTIL ItemNum% > MaxItems%
            ItemNum% = MaxItems%
            row% = row% - 1
            COLOR FgHilit%, BgHilit%
            LOCATE row%, Column%
            PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";
        CASE DnArrow%, SpaceBar%, Enter%
            IF Kee% = SpaceBar% OR Kee% = Enter% THEN
                IF Snd% THEN CALL Pip
                LOCATE row%, Column% - 1
                IF Tagged%(ItemNum%) THEN
                    COLOR FgNorm%, BgNorm%
                    PRINT " ";
                    Tagged%(ItemNum%) = 0
                    QtySelected% = QtySelected% - 1
                ELSE
                    istagged% = -1
                    untagged% = 0
                    COLOR FgTag%, BgNorm%
                    PRINT SelectChar$;
                    COLOR FgNorm%, BgNorm%
                    Tagged%(ItemNum%) = -1
                    QtySelected% = QtySelected% + 1
                END IF
            END IF
            IF ItemNum% <> MaxItems% THEN
                COLOR FgNorm%, BgNorm%
                LOCATE row%, Column%
                PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";
                row% = row% + 1
                IF row% = LoRow% + 1 THEN
                    ItemNum% = ItemNum% + 1
                    COLOR FgHilit%, BgHilit%
                    row% = row% - 1
                    LOCATE row%, Column%
                    PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";
                    RowI% = row%
                    GOSUB CheckTagged
                    Temp% = ItemNum%
                    ItemNum% = ItemNum% - 1
                    COLOR FgNorm%, BgNorm%
                    FOR j% = LoRow% - 1 TO UpRow% STEP -1
                        LOCATE j%, Column%
                        PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";
                        RowI% = j%
                        GOSUB CheckTagged
                        ItemNum% = ItemNum% - 1
                    NEXT
                    ItemNum% = Temp%
                ELSE
                    ItemNum% = ItemNum% + 1
                    COLOR FgHilit%, BgHilit%
                    LOCATE row%, Column%
                    PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";
                    RowI% = row%
                    GOSUB CheckTagged
                END IF
            END IF
        CASE UpArrow%                                 'Up
            IF ItemNum% <> 1 THEN
                COLOR FgNorm%, BgNorm%
                LOCATE row%, Column%
                PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";
                row% = row% - 1
                IF row% = UpRow% - 1 THEN
                    ItemNum% = ItemNum% - 1
                    COLOR FgHilit%, BgHilit%
                    row% = row% + 1
                    LOCATE row%, Column%
                    PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";
                    RowI% = row%
                    GOSUB CheckTagged
                    Temp% = ItemNum%
                    ItemNum% = ItemNum% + 1
                    COLOR FgNorm%, BgNorm%
                    FOR j% = UpRow% + 1 TO LoRow%
                        LOCATE j%, Column%
                        PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";
                        RowI% = j%
                        GOSUB CheckTagged
                        ItemNum% = ItemNum% + 1
                    NEXT
                    ItemNum% = Temp%
                ELSE
                    ItemNum% = ItemNum% - 1
                    COLOR FgHilit%, BgHilit%
                    LOCATE row%, Column%
                    PRINT " " + Item$(ItemNum%) + SPACE$(MaxLength% - LEN(Item$(ItemNum%))) + " ";
                    RowI% = row%
                    GOSUB CheckTagged
                END IF
            END IF
        END SELECT
    LOOP UNTIL quitflag%

CheckTagged:

    LOCATE RowI%, Column% - 1
    IF Tagged%(ItemNum%) THEN
        COLOR FgTag%, BgNorm%
        PRINT SelectChar$;
        COLOR FgNorm%, BgNorm%
    ELSE
        COLOR FgNorm%, BgNorm%
        PRINT " ";
    END IF
    RETURN

END SUB

