DECLARE SUB Transmute ()
DECLARE SUB TheCircle ()
DECLARE SUB Scanner ()
DECLARE SUB RandomSelection ()
DECLARE SUB ChangeColors (red!, green!, blue!)
DECLARE SUB PrintFile ()
COLOR 7, 1
CLS
PRINT "This program demonstrates color changing using OUT."
PRINT "C - The Circle"
PRINT "R - Random color selections of text"
PRINT "S - Scan 64 colors, foreground and background"
PRINT "T - Transmute colors of text"
PRINT "X - Exit";
ds$ = UCASE$(INPUT$(1))
IF ds$ = "C" THEN CALL TheCircle
IF ds$ = "R" THEN CALL RandomSelection
IF ds$ = "S" THEN CALL Scanner
IF ds$ = "T" THEN CALL Transmute
IF ds$ = "X" THEN SYSTEM
RUN

SUB ChangeColors (red, green, blue)
OUT &H3C8, 7
OUT &H3C9, red
OUT &H3C9, green
OUT &H3C9, blue
LOCATE 25, 1
COLOR 12, 0
PRINT USING "##  "; red;
COLOR 10, 0
PRINT USING "##  "; green;
COLOR 9, 0
PRINT USING "##"; blue;

END SUB

SUB PrintFile
OPEN "I", 1, "colors.bas"
DO UNTIL EOF(1)
    LINE INPUT #1, L$
    PRINT L$
LOOP
CLOSE

END SUB

SUB RandomSelection
COLOR 7, 1
CLS
CALL PrintFile
red = 60: green = 60: blue = 60
RANDOMIZE TIMER
DO
    r = INT(RND(1) * 3) - 1
    g = INT(RND(1) * 3) - 1
    b = INT(RND(1) * 3) - 1
    red = ABS(red + r) MOD 64
    green = ABS(green + g) MOD 64
    blue = ABS(blue + b) MOD 64
    CALL ChangeColors(red, green, blue)
    FOR i = 1 TO 10000
    : NEXT
LOOP WHILE INKEY$ = ""

END SUB

SUB Scanner
'A Holiday gift from my IDE to yours. Enjoy!
'64 Color text mode sampler. Requires EGA or better.

       CONST up = 72, down = 80, right = 77, left = 75
       'OPTION BASE 0
       DIM ECOLS(64) AS STRING * 25
       ECOLS(0) = "Black": ECOLS(1) = "Blue": ECOLS(2) = "Green"
       ECOLS(3) = "Cyan": ECOLS(4) = "Red": ECOLS(5) = "Magenta"
       ECOLS(6) = "Yellow Brown": ECOLS(7) = "Light Gray"
       ECOLS(8) = "Dark Blue": ECOLS(9) = "Bright Blue"
       ECOLS(10) = "Medium Celery": ECOLS(11) = "Sky Blue"
       ECOLS(12) = "Dark Fuchia": ECOLS(13) = "Lilac"
       ECOLS(14) = "Light Yellow": ECOLS(15) = "Light Blue Purple "
       ECOLS(16) = "Kelly Green": ECOLS(17) = "Light Blue"
       ECOLS(18) = "Bright Green": ECOLS(19) = "Mint Green"
       ECOLS(20) = "Brown": ECOLS(21) = "Light Magenta"
       ECOLS(22) = "Bright Light Green": ECOLS(23) = "Light Green Yellow "
       ECOLS(24) = "Blue Gray": ECOLS(25) = "Bright Light Blue "
       ECOLS(26) = "Light Green": ECOLS(27) = "Light Cyan"
       ECOLS(28) = "Light Brick Red": ECOLS(29) = "Light Purple"
       ECOLS(30) = "Yellow Green": ECOLS(31) = "Very Light Cyan"
       ECOLS(32) = "Deep Red": ECOLS(33) = "Purple"
       ECOLS(34) = "Medium Green": ECOLS(35) = "Light Gray Cyan"
       ECOLS(36) = "Bright Red": ECOLS(37) = "Fuchia"
       ECOLS(38) = "Gold": ECOLS(39) = "Light Pink"
       ECOLS(40) = "Deep Purple": ECOLS(41) = "Bright Purple"
       ECOLS(42) = "Celery": ECOLS(43) = "Light Sky Blue"
       ECOLS(44) = "Medium Fuchia": ECOLS(45) = "Medium Magenta"
       ECOLS(46) = "Tan": ECOLS(47) = "Light Lilac"
       ECOLS(48) = "Olive Green": ECOLS(49) = "Medium Purple Blue"
       ECOLS(50) = "Neon Green": ECOLS(51) = "Medium Mint Green"
       ECOLS(52) = "Orange": ECOLS(53) = "Medium Pink"
       ECOLS(54) = "Bright Yellow": ECOLS(55) = "Light Manilla"
       ECOLS(56) = "Gray": ECOLS(57) = "Medium Blue"
       ECOLS(58) = "Green Yellow": ECOLS(59) = "Light Blue Cyan"
       ECOLS(60) = "Dark Peach": ECOLS(61) = "Medium Lilac"
       ECOLS(62) = "Yellow": ECOLS(63) = "White"

       CLS
       COLOR 15, 0
     LOCATE 2, 10
     PRINT "Use "; CHR$(24); CHR$(25); " to adjust Background"
     LOCATE 3, 10
     PRINT "Use "; CHR$(27); CHR$(26); " to adjust Foreground"
     LOCATE 4, 10
     PRINT "Press ESCape to Quit"

       PALETTE 3, 0
       PALETTE 10, 0

       DO

          LOCATE 5, 10: COLOR 15, 0
          PRINT USING "Background = ##  &"; BG%; ECOLS(BG%)
          LOCATE 6, 10
          PRINT USING "Foreground = ##  &"; FG%; ECOLS(FG%)
          COLOR 10, 3
          LOCATE 8, 10: PRINT "  EGA  Color Sampler  "

          PALETTE 3, BG%
          PALETTE 10, FG%

           DO
            scroll$ = INKEY$
           LOOP WHILE scroll$ = ""

           IF LEN(scroll$) = 1 THEN

              SELECT CASE scroll$
                  CASE CHR$(27)
                      EXIT DO
                  CASE ELSE
                      SOUND 50, .5
              END SELECT

           ELSE

              SELECT CASE RIGHT$(scroll$, 1)
                  CASE CHR$(up)
                    BG% = BG% + 1
                    IF BG% > 63 THEN
                       BG% = 0
                    END IF
                  CASE CHR$(down)
                    BG% = BG% - 1
                    IF BG% < 0 THEN
                       BG% = 63
                    END IF
                  CASE CHR$(right)
                    FG% = FG% + 1
                    IF FG% > 63 THEN
                       FG% = 0
                    END IF
                  CASE CHR$(left)
                    FG% = FG% - 1
                    IF FG% < 0 THEN
                       FG% = 63
                    END IF
              END SELECT
           END IF
       LOOP


END SUB

SUB TheCircle
' Color demo using OUT statements
 ' By Andy Thomas -- August, 1993

 DEFINT A-Z
 SCREEN 13            'VGA 320x200x265 color mode
 Attr% = 1            ' For this we'll only use one color

 FOR i = 1 TO 50
  CIRCLE (165, 80), i, Attr%    'display something
 NEXT i

 RANDOMIZE TIMER      ' let's start with a random color

 green = 64 * RND     ' range = 0 to 63
 red = 64 * RND       ' range = 0 to 63
 blue = 64 * RND      ' range = 0 to 63

 OUT &H3C8, Attr%     ' Color we're using
 OUT &H3C9, red       ' set red
 OUT &H3C9, green     ' set green
 OUT &H3C9, blue      ' set blue

 DO
   OUT &H3C7, Attr%       ' Color we're using
   red = INP(&H3C9)       ' get red value
   green = INP(&H3C9)     ' get green value
   blue = INP(&H3C9)      ' get blue value

   A$ = INKEY$            ' get keypress
   SELECT CASE A$         ' determine keypress
   CASE "R"
     IF red <> 63 THEN red = red + 1
   CASE "G"
     IF green <> 63 THEN green = green + 1
   CASE "B"
     IF blue <> 63 THEN blue = blue + 1
   CASE "r"
     IF red <> 0 THEN red = red - 1
   CASE "g"
     IF green <> 0 THEN green = green - 1
   CASE "b"
     IF blue <> 0 THEN blue = blue - 1
   CASE "+"
     IF red <> 63 THEN red = red + 1
     IF green <> 63 THEN green = green + 1
     IF blue <> 63 THEN blue = blue + 1
   CASE "-"
     IF red <> 0 THEN red = red - 1
     IF green <> 0 THEN green = green - 1
     IF blue <> 0 THEN blue = blue - 1
END SELECT

   OUT &H3C8, Attr%          ' Color we're using
   OUT &H3C9, red            ' set red
   OUT &H3C9, green          ' set green
   OUT &H3C9, blue           ' set blue

   LOCATE 20, 1
   PRINT "Press R, G, or B to change colors."
   PRINT "+ and - change all."
   PRINT "<ESC> to end."
   PRINT "Lower case lessens,"
   PRINT "Upper case increases.";
   LOCATE 25, 1
   PRINT USING "Red = ##    Green = ##   Blue = ##"; red; green; blue;

 LOOP UNTIL A$ = CHR$(27)
END SUB

DEFSNG A-Z
SUB Transmute
COLOR 7, 0
CLS
CALL PrintFile
FOR red = 0 TO 63
    FOR green = 0 TO 63
        FOR blue = 0 TO 63
        CALL ChangeColors(red, green, blue)
        NEXT blue
        IF INKEY$ = CHR$(27) THEN EXIT SUB
        IF INKEY$ <> "" THEN EXIT FOR
    NEXT green
NEXT red

END SUB
