DEFINT A-Z
DECLARE FUNCTION VMenu% (VSel$(), Row%, Col%, FixedWidth%, Hilight%, Normal%)
DECLARE SUB SetWidth (BYVAL ScrnWidth%)  'ScrnWidth% = Current screen width.
DECLARE SUB SetVSeg (BYVAL VSeg%)        'VSeg% = Current video segment
DECLARE SUB QPrint (BYVAL Row%, BYVAL Col%, BYVAL TSeg%, BYVAL TOff%, BYVAL TLen%, BYVAL Attr%)
DECLARE SUB BackFill (BYVAL Row%, BYVAL Col%, BYVAL Length%, BYVAL Attr%)
DECLARE SUB ForeFill (BYVAL Row%, BYVAL Col%, BYVAL TSeg%, BYVAL TOff%, BYVAL TLen%)

'In all cases:
'
'Row   = Printing row
'Col   = Printing column
'TSeg  = Source text segment (Use varseg/sseg)
'TOff  = Source text offset  (Use SADD/VARPTR)
'TLen  = Source text length  (Use LEN)
'Attr  = Screen attributes   (First 4 bits forground, last 4 background)

DECLARE SUB QuickPrint (Row%, Col%, Text$, Attr%)
DECLARE SUB TextFill (Row%, Col%, Text$)
DEFINT A-Z

'REQUIRED startup functions:

SetWidth 80
SetVSeg &HB800 'Change to &HB000 for moncrome

'Example code:

REDIM Menu1(1 TO 3) AS STRING

Menu1(1) = "Option One"
Menu1(2) = "Option Two"
Menu1(3) = "Option Three"

COLOR 14, 1
CLS

Opt = VMenu(Menu1(), 0, 0, 0, &H1E, &H4E)

QuickPrint 4, 0, "You selected option " + Menu1(Opt) + "!", &H1E

SUB QuickPrint (Row%, Col%, Text$, Attr%)
    IF LEN(Text$) > 0 THEN
        TextLen% = LEN(Text$)
        QPrint Row%, Col%, SSEG(Text$), SADD(Text$), TextLen%, Attr%
    END IF
END SUB

SUB TextFill (Row%, Col%, Text$)
IF LEN(Text$) > 0 THEN ForeFill Row%, Col%, SSEG(Text$), SADD(Text$), LEN(Text$)
END SUB

FUNCTION VMenu (VSel$(), Row%, Col%, FixedWidth, Hilight%, Normal%)
MaxLen% = 0
Size = UBOUND(VSel$)
Barline = 1
ExitFlag = -255

IF FixedWidth = 0 THEN
    FOR Count = 1 TO Size
        FindMax = LEN(VSel$(Count))
        IF FindMax > MaxLen THEN MaxLen = FindMax
    NEXT
ELSE
    MaxLen = FixedWidth
END IF

FOR Count = 1 TO Size
    IF Count = 1 THEN CLR = Hilight% ELSE CLR = Normal%
    QuickPrint Row% + Count - 1, Col%, STRING$(MaxLen%, " "), CLR
    QuickPrint Row% + Count - 1, Col%, VSel$(Count), CLR
NEXT

DO
    DO
        IKey$ = INKEY$
    LOOP UNTIL IKey$ <> ""

    SELECT CASE IKey$
        CASE CHR$(0) + "H"'up arrow key
            Barline = Barline - 1
            IF Barline = 0 THEN Barline = Size
        CASE CHR$(0) + "P"'down arrow key
            Barline = Barline + 1
            IF Barline = Size + 1 THEN Barline = 1
        CASE CHR$(13) 'Enter
            ExitFlag = True
        CASE CHR$(27) 'Esc
            ExitFlag = 0
    END SELECT

    FOR Count = 1 TO Size
        IF Count = Barline THEN
            BackFill Row% + Count - 1, Col%, MaxLen, Hilight%
        ELSE
            BackFill Row% + Count - 1, Col%, MaxLen, Normal%
        END IF
    NEXT
LOOP UNTIL ExitFlag <> -255

IF ExitFlag = True THEN
    VMenu = Barline
ELSE
    VMenu = 0
END IF
END FUNCTION

