;--------------------- X-RANDOM.ASM -----------------------

        .MODEL Medium, Basic

        .DATA

        EVEN

RND_Seed        DW      7397, 29447, 802 
RND_Mult        DW      179, 183, 182
RND_ModV        DW      32771, 32779, 32783

        .CODE

X_RAND  PROC    FAR		;(NEAR OR FAR)

        MOV     CX,3            ;repeat for each Seed, Mult,
                                ;and Mod value
        XOR     BX,BX           ;BX is the data index
        MOV     SI,BX           ;clear the accumulator

@XR_Again:
        MOV     AX,RND_Seed[BX] ;load the initial seed
        MUL     RND_Mult[BX]    ;multiply it
        DIV     RND_ModV[BX]    ;and obtain the Mod value
        MOV     RND_Seed[BX],DX ;save that for the next time

        ADD     SI,DX           ;add it into the accumulator

        INC     BX
        INC     BX              ;point to the next set of values
        DEC     CX              ;until all three values are
        JNZ     @XR_Again       ;Exhausted

        ;SI = Acculmulator... I.e. Random 16 #
        ;DX:AX = Values used by process...

        MOV     AX, SI          ;Random # in AX

        RET                     ;back to BASIC with AX holding
                                ;the result

X_RAND  ENDP
	END